function [axhandles]=drawcheckbox(parent,peer,pos,value,words,callback)
%
% peer is handle of thing to be scrolled (will be sent to callback)
% minvalue is leftmost pixel of viewport
% maxvalue is rightmost pixel of viewport
% jump is visible horizontal range of viewport (in pixels)
%note, callback must accept src and ev inputs, and a third input for slider
%value.
%note: visiblility is automatically turned off when jump is greater than
%scrollable range.
%callback must take 3 inputs: (peer,eventdata,value)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(parent);

pos(3)=13; %enforce correct size
pos(4)=13;

a=axes('parent',parent,'units','pixels','position',pos,'color',[.8 .8 .8]);

checkon=imread('checkon.bmp');
checkoff=imread('checkoff.bmp');

if value
    img=image(checkon,'parent',a,'hittest','on','buttondownfcn',{callback,peer},'userdata',0);
else
    img=image(checkoff,'parent',a,'hittest','on','buttondownfcn',{callback,peer},'userdata',1);
end

text(18,13,words,'parent',a,'vertical','baseline');

set(a,'visible','off','userdata',value,'tag','vhslideax','hittest','on','buttondownfcn',{callback,peer})

set(a,'userdata',[]);

%callback(img,[],peer);

axhandles=a;
% 
% if round(jump)>=round(maxvalue-minvalue)
%     set([bg kn up down],'visible','off')
% end
% 
% function vslideclick(src,ev,minvalue,maxvalue,callback,peer) 
% clicked=get(gca,'currentpoint');
% ylim=get(gca,'ylim');
% sliderpos=get(gca,'position');
% ycoord=clicked(1,2,1);
% %knobax=findobj(get(gca,'parent'),'tag','hknob');
% userdata=get(gca,'userdata');
% knobax=userdata(1);
% knobpos=get(knobax,'position');
% 
% oldcoord=knobpos(2)-sliderpos(2);
% jump=knobpos(4);
% 
% if ycoord<19 %small up click
%     newcoord=oldcoord+5;
%     if newcoord>sliderpos(4)-19-jump;newcoord=sliderpos(4)-19-jump;end;%19;newcoord=19;end;
% 
% elseif ycoord<ylim(2)-(knobpos(2)-sliderpos(2))-jump %large click up
%     newcoord=oldcoord+jump;
%     
%     %if newcoord<19;newcoord=19;end;
% if newcoord>sliderpos(4)-19-jump;newcoord=sliderpos(4)-19-jump;end;%19;newcoord=19;end;
% 
% elseif ycoord>(ylim(2)-19) %small click down
%     newcoord=oldcoord-5;
%     %if newcoord>sliderpos(4)-19-jump;newcoord=sliderpos(4)-19-jump;end;
%     if newcoord<19;newcoord=19;end;
% else %large click down
%     newcoord=oldcoord-jump;
%     %if newcoord>sliderpos(3)-19-jump;newcoord=sliderpos(3)-19-jump;end;
%     if newcoord<19;newcoord=19;end;
% end
% 
% knobpos(2)=newcoord+sliderpos(2);
% set(knobax,'position',knobpos)%,'userdata',knobpos(1));
% 
% newvalue=(newcoord-19)*(maxvalue-minvalue)/(ylim(2)-ylim(1)-39);
% callback(peer,[],newvalue);
% 
% set(gca,'userdata',[knobax newvalue])
% 
% 
% function knobclick(src,ev,minvalue,maxvalue,callback,peer)
% fighandle=ancestor(src,'figure');
% hslideax=get(gca,'userdata');
% clicked=get(hslideax,'currentpoint');
% startpos=clicked(1,2,1);
% origpos=get(gca,'position');
% %set(gca,'userdata',startpos);
% set(fighandle,'windowbuttonmotionfcn',{@knobslide,startpos,origpos,minvalue,maxvalue,callback,peer})
% set(fighandle,'windowbuttonupfcn',@knobdone)
% 
% 
% function knobslide(src,ev,startpos,origpos,minvalue,maxvalue,callback,peer) %#ok<INUSL>
% hslideax=get(gca,'userdata');
% ylim=get(hslideax,'ylim');
% clicked=get(hslideax,'currentpoint');
% sliderpos=get(hslideax,'position');
% ycoord=clicked(1,2,1);
% %userdata=get(hslideax
% %knobax=findobj(ancestor(gca,'uipanel'),'tag','hknob');
% knobax=gca;
% knobpos=origpos;
% 
% oldcoord=knobpos(2)-sliderpos(2);
% jump=knobpos(4);
% 
% shift=ycoord-startpos;
% 
% newcoord=oldcoord-shift;
% % if newcoord<19+sliderpos(1);newcoord=19+sliderpos(1);end;
% % if newcoord>sliderpos(1)+sliderpos(3)-19-jump;newcoord=sliderpos(1)+sliderpos(3)-19-jump;end;
% 
% if newcoord>sliderpos(4)-19-jump;newcoord=sliderpos(4)-19-jump;end
% if newcoord<19;newcoord=19;end;
% 
% 
% knobpos(2)=newcoord+sliderpos(2);
% set(knobax,'position',knobpos); %userdata, xcoord)
% 
% newvalue=(newcoord-19)*(maxvalue-minvalue)/(ylim(2)-ylim(1)-39);
% callback(peer,[],newvalue);
% 
% set(hslideax,'userdata',[knobax newvalue]);
% 
% 
% function knobdone(src,ev)
% handles=guidata(src);
% fighandle=handles.fig;
% %fighandle=ancestor(src,'figure');
% set(fighandle,'windowbuttonmotionfcn','')
% set(fighandle,'windowbuttonupfcn','')