function ravecreatetextbox(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
%get format inputs:
udata=get(handles.fakeax(handles.activeindex),'userdata');

targetaxes=handles.activegraph;
targetindex=find(handles.allgraphs==targetaxes);

a=udata.view.analysis;
d=udata.view.dataset; %data set index

%hide axes:
set(targetaxes,'visible','off','xticklabel','','yticklabel','')
set(handles.fakeax(targetindex),'visible','off')
set(handles.fakerax(targetindex),'visible','off')

cla(targetaxes);

indata=udata.view.expression;

if udata.format.fontstyle==3
    style={'fontweight','bold','fontangle','italic'};
elseif udata.format.fontstyle==1
    style={'fontweight','bold','fontangle','normal'};
elseif udata.format.fontstyle==2
    style={'fontweight','normal','fontangle','italic'};
else
    style={'fontweight','normal','fontangle','normal'};
end

color=udata.format.color;
set(handles.allblockers(handles.activeindex),'facecolor',udata.format.bgcolor)

%make text:
text(0,.5,indata,'parent',targetaxes,...
    'hittest','off','fontname',udata.format.fontname,'fontsize',udata.format.fontsize,...
    'color',color,'ver','middle',style{:});






