function raveupdatederivativeprofilerxdials(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
getudata;
d=udata.view.dataset;
a=udata.view.analysis;
xcol=udata.view.x;
xdials=handles.xdials{udata.view.dataset}{udata.view.analysis};
udata.view.xdials=xdials;

% xdials(udata.view.x(index))=val;

set(handles.fakeax(handles.activeindex),'userdata',udata)


thesedials=xdials(udata.view.x);
for g=1:numel(thesedials)
    
    val=thesedials(g);
    thistype=handles.datatype{d}{udata.view.x(g)};
    
    %make text label:
    if ~any(strcmp(thistype,{'string','logical'}))
        valtext=strtrim(sprintf('%5.5g',val));
    elseif strcmp(thistype,'string')
        valtext=handles.discretevalues{d}{a}{xcol(g)}{val};
    else %logical
        if val
            valtext=handles.prefs.logicaltrue;
        else
            valtext=handles.prefs.logicalfalse;
        end
    end

    %set xlabel:
    set(handles.profilers.xhair{handles.activeindex}(:,g),'xdata',[val val])
    set(get(handles.subfakeax{handles.activeindex}(end,g),'xlabel'),'string',{' ';' ';['\color[rgb]{',udata.format.linecolorString,'} ',valtext]},'verticalalignment','top','interpreter','tex');
    
    
    %set(handles.profilers.xhair{ai}(:,g),'xdata',[thesedials(g) thesedials(g)])
end


%calculate profiler data for each graph:
cols=length(udata.view.x);
if udata.view.singleyaxis
    rows=1;
else
    
    rows=length(udata.view.y);
end

numpts=udata.view.numpts;
xcol=udata.view.x;
ycol=udata.view.y;
numy=numel(ycol);

%get type of each variable:
datatypes=handles.datatype{d}(udata.view.x);

totalrows=zeros(size(datatypes)); %totalrows lists the total number of rows in the input data that correspond to the graph of this input.
%thus final input data has sum(totalrows) rows.

xmin=handles.minlimit{d}{a};
xmax=handles.maxlimit{d}{a};

step=(xmax-xmin)/numpts;
xsteps=cell(1,numel(datatypes));

for j=1:numel(datatypes);
    switch datatypes{j}
        case 'constant'
            xsteps{j}=xdials(xcol(j));
            totalrows(j)=1;
        case 'continuous'
            %totalrows(j)=numpts+1;
            xsteps{j}=sort([xmin(xcol(j)):step(xcol(j)):xmax(xcol(j)) xdials(xcol(j))]);
            totalrows(j)=numel(xsteps{j});
        case 'integer'
            if numel(handles.discretevalues{d}{a}{xcol(j)})<20
                %totalrows(j)=numel(handles.discretevalues{d}{a}{xcol(j)});
                xsteps{j}=handles.discretevalues{d}{a}{xcol(j)};
                totalrows(j)=numel(xsteps{j});
            else
                %totalrows(j)=numpts+1;
                xsteps{j}=sort([xmin(xcol(j)):step(xcol(j)):xmax(xcol(j)) xdials(xcol(j))]);
                totalrows(j)=numel(xsteps{j});
            end
        case 'discrete'
            %if numel(handles.discretevalues{d}{a}{xcol(j)})<12
            % totalrows(j)=numel(handles.discretevalues{d}{a}{xcol(j)});
            xsteps{j}=handles.discretevalues{d}{a}{xcol(j)};
            totalrows(j)=numel(xsteps{j});
            %else
            %    totalrows(j)=12;
            %end
        case 'string'
            %totalrows(j)=numel(handles.discretevalues{d}{a}{xcol(j)});
            xsteps{j}=handles.discretevalues{d}{a}{xcol(j)};
            totalrows(j)=numel(xsteps{j});
        case 'logical'
            %totalrows(j)=2;
            xsteps{j}=[0 1];
            totalrows(j)=numel(xsteps{j});
    end
end

rowz=sum(totalrows);


xfixed=repmat(xdials,[rowz,1]);

%convert to cell if strings are present:
if any(strcmp('string',datatypes))
    %xfixed=mat2cell(xfixed,ones(size(xfixed,1),1),ones(size(xfixed,2),1));
    xfixed=num2cell(xfixed);
    for k=1:cols
        % xfixed((k-1)*(numpts+1)+1:k*(numpts+1),xcol(k))=xsteps(:,xcol(k));
        [xfixed{sum(totalrows(1:k-1))+1:sum(totalrows(1:k)),xcol(k)}]=deal(xsteps{k});
    end
    
else
    for k=1:cols
        %xfixed((k-1)*(numpts+1)+1:k*(numpts+1),xcol(k))=xsteps(:,xcol(k));
        xfixed(sum(totalrows(1:k-1))+1:sum(totalrows(1:k)),xcol(k))=xsteps{k};
    end
end


%evaluate the functions:

yvalues=raveevaluateregression(src,d,udata.view.y,xfixed);
ycurrent=raveevaluateregression(src,d,udata.view.y,xdials);

%put results of each response in a seperate cell:
yvalues=mat2cell(yvalues,size(yvalues,1),ones(1,numy));
ycurrent=mat2cell(ycurrent,size(ycurrent,1),ones(1,numy));

%and put each x for each resposne in its own cell too:
for zz=1:rows
    yvalues{zz}=mat2cell(yvalues{zz},totalrows,1);
end


for tt=1:rows
    set(get(handles.subfakeax{handles.activeindex}(tt,1),'ylabel'),'string',{['\color[rgb]{',udata.format.linecolorString,'} ',num2str(ycurrent{tt},5)];'';''});
    
    for cc=1:cols
        if  ~any(strcmp(datatypes{cc},{'continuous';'constant'})) %if this variable is discrete
            allowed=handles.discretevalues{d}{a}{xcol(cc)};
            endind=numel(allowed);
            
            intsides=repmat(2:(endind-1),3,1);
            ymap=[1 1 intsides(:)' endind endind];
            
            xvals=xsteps{cc}(:); %force to be column.
            xintermediates=xvals+[diff(xvals)./2;0];
            
            xvals=sort([xvals;xintermediates(1:end-1)]);
            
            xmap=repmat(2:2:2*(endind-1),3,1);
            xmap(end,:)=xmap(end,:)+ones(size(xmap(end,:)));
            
            xmap=[1 xmap(:)'];
            
            set(handles.profilers.yhair{handles.activeindex}(tt,cc),'ydata',[ycurrent{tt} ycurrent{tt}])
            set(handles.profilers.main{handles.activeindex}(tt,cc),'ydata',yvalues{tt}{cc}(ymap),'xdata',xvals(xmap))
            
        else
            
            set(handles.profilers.yhair{handles.activeindex}(tt,cc),'ydata',[ycurrent{tt} ycurrent{tt}])
            set(handles.profilers.main{handles.activeindex}(tt,cc),'ydata',yvalues{tt}{cc},'xdata',xsteps{cc})
        end
        
    end
end

%if ai~=handles.activeindex;raverasterfarian(handles.fig,[],ai);end;
%        drawnow;
handles=guidata(handles.fig);

ravedrawconstraint(handles.allgraphs(handles.activeindex),handles.activeindex,udata.view.constraints);


