function raveinitializecarpet2d(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);


inputs.y=[];
inputs.x=[];
inputs.dataset=[];
%inputs.xdials=[];

for dd=numel(handles.alldata):-1:1 %for each dataset:
    z=find(handles.isfunction{dd},1);
    if ~isempty(z)
        inputs.z=z;
        inputs.dataset=dd;
        X=handles.funvars{dd}{z};
        X=X(~strcmp('constant',handles.datatype{dd}(X)));
        inputs.x=X(1);
        if numel(X)>1
            inputs.y=X(2);
        else
            inputs.y=X(1);
        end

        udata.view.isvalid=1;
        break
    end
end

if isempty(z) || isempty(inputs.x);
    inputs.x=[];
    inputs.y=[];
    inputs.z=[];
    inputs.dataset=1;
    udata.view.isvalid=0;
end

%initialize subplot axes structure:
handles.subax{handles.activeindex}=[];
handles.subfakeax{handles.activeindex}=[];
handles.subfakerax{handles.activeindex}=[];

udata.manage.israsterized=0;

%make viewtab info:
udata.view.analysis=1;
udata.view.dataset=1;
udata.view.y=1;
udata.view.x=1;
udata.view.z=1; %z is variable to sweep through
udata.view.c=1; %c is variable to take steps of
udata.view.s=0; %unused

udata.view.steps=[];

udata.view.response=0; %response check box value
udata.view.exclude=0; %exclude constant check box value
udata.view.layout='square'; %options: square, lower, upper, rectangle.
%       udata.view.mainhandles=cell(0); %[vector of contour handles returned by contourplot function]
%       udata.view.tracerhandles=cell(0); %[verticaltracer horizontaltracer]
udata.view.numpts1=10; %number of levels to test sweepvar1
udata.view.numpts2=10; %number of levels to test sweepvar2
udata.view.constraints=0; %indicies of constraints drawn on this graph.

udata.view.isvisible1=1;
udata.view.isvisible2=1;


%make format tab info:
udata.format.bg=1; %index for background color;
udata.format.grid=1; %index for grid;
udata.format.marker='s'; % marker string
udata.format.markersize=2; %marker size
udata.format.mcmap1=4; %marker colormap (index?)
udata.format.mcmap2=4; %marker colormap (index?)


udata.format.markerfill=2;
udata.format.linestyle='-'; %line style string
udata.format.linesize=2; %line thickness;
udata.format.lcmap=1; %line colormap (index?)
udata.format.mcheck=1; %marker check box value
udata.format.lcheck=1; %line check box value
udata.format.colorbar=0;
udata.format.cbarhandle=0;
udata.format.title='';
udata.format.reversecolors1=0;
udata.format.reversecolors2=0;
udata.format.bold=0; %bold tracers
udata.format.usevariablecolors=0; %for tracers
udata.format.tracercolor=handles.colors.text;
udata.format.showpoints=0;
udata.format.nxlabelrows=0;

%make explre tab info:


udata.explore.method=cell(0);
udata.explore.option=1;




%set fakeax userdata (tab info)
set(handles.fakeax(handles.activeindex),'userdata',udata);

%make the graph
ravecreatecarpet2d(handles.fig,[]);
