function raveupdatepreferencesliderspreferences(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
%get format inputs:
udata=get(handles.fakeax(handles.activeindex),'userdata');

xcol=udata.view.x;
d=udata.view.dataset; %data set index

prefs=handles.preferences{d}(udata.view.x);

if isempty(xcol) %no response variables in data set.  
    return
end

startvalues=sqrt(prefs)*.3+.43;
startvalues(isinf(startvalues))=0.58; %mid range.
startvalues(isnan(startvalues))=0.58;

nvars=numel(xcol);

for t=1:nvars
   val=prefs(t);
    
%     %move marker within bounds
%     if val>0.73
%         val=0.73;
%     elseif val<0.43
%         val=0.43;
%     end

    %newval=((val-0.43)/0.3).^2;
    set(udata.view.blobs(t),'xdata',startvalues(t),'markerfacecolor',udata.format.cmap(round((val^.25)*127)+1,:));
    valtext=strtrim(sprintf('%5.5g',val));
    set(udata.view.valtexts(t),'string',valtext,'color',[0 0 0]);
end


