function filterbarclick(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%NOTE: all of these functions need to work REGARDLESS OF WHICH GRAPH IS
%SELECTED. so no using activeindex or activegraph!

handles=guidata(src);

set(handles.fig,'windowbuttonmotionfcn',{@pprofslide,src})
set(handles.fig,'windowbuttonupfcn',{@pprofdone,src})

clicked=get(get(src,'parent'),'currentpoint');
firstval=clicked(1,1);

%lims=[0.43 0.73];
%thisvar=get(gco,'userdata');

ai=find(handles.allgraphs==get(src,'parent'),1);
udata=get(handles.fakeax(ai),'userdata');

idx=udata.view.blobs==src;
lims=get(udata.view.lowfilterblobs(idx),'xdata');
leftoffset=firstval-lims(1);

set(handles.fig,'windowbuttonmotionfcn',{@pprofslide,src,firstval,leftoffset})
set(handles.fig,'windowbuttonupfcn',{@pprofdone,src})



function pprofslide(fig,eventdata,src,firstval,leftoffset) %#ok<INUSL>
handles=guidata(fig);
ai=find(handles.allgraphs==get(src,'parent'));
udata=get(handles.fakeax(ai),'userdata'); %#ok<FNDSB>

d=udata.view.dataset;
a=udata.view.analysis;

thisvar=get(gco,'userdata');
thistype=handles.datatype{udata.view.dataset}{thisvar};
allowablevalues=handles.discretevalues{udata.view.dataset}{udata.view.analysis}{thisvar};

%if ~isempty(fig) %if this function is called as a callback: (get mouse location and slide bars)
clicked=get(get(src,'parent'),'currentpoint');
val=clicked(1,1);

width=diff(get(src,'xdata'));


%move marker within bounds

lims=[0.43 0.73];
switch get(src,'tag')
    case 'low'
        lims(2)=get(findobj(udata.view.highfilterblobs,'userdata',thisvar),'xdata');
        idx=udata.view.lowfilterblobs==src;
        udata.view.lowfilters(thisvar)=get(src,'xdata');
    case 'high'
        lims(1)=get(findobj(udata.view.lowfilterblobs,'userdata',thisvar),'xdata');
        idx=udata.view.highfilterblobs==src;
        udata.view.highfilters(thisvar)=get(src,'xdata');
end

if val-leftoffset+width>lims(2)
    val=lims(2)-width+leftoffset;
elseif val-leftoffset<lims(1)
    val=lims(1)+leftoffset;
end



newminval=val-leftoffset;
newmaxval=val-leftoffset+width;

idx=(udata.view.blobs==src);

set(udata.view.lowfilterblobs(idx),'xdata',newminval);
set(udata.view.highfilterblobs(idx),'xdata',newmaxval);
set(gco,'xdata',[newminval newmaxval])


%convert to real values:
%round to nearest allowable point:
if ~any(strcmp(thistype,{'constant','continuous'}))  
    allowed=linspace(.43,.73,numel(allowablevalues));
    minval=allowed(abs(allowed-newminval)==min(abs(allowed-newminval)));
    minval=minval(1); %in case above line has 2 mins.
    newminval=allowablevalues(abs(allowed-minval)==min(abs(allowed-minval)));
    
    maxval=allowed(abs(allowed-newmaxval)==min(abs(allowed-newmaxval)));
    maxval=maxval(1); %in case above line has 2 mins.
    newmaxval=allowablevalues(abs(allowed-maxval)==min(abs(allowed-maxval)));
else
    range=[handles.minlimit{d}{a}(thisvar) handles.maxlimit{d}{a}(thisvar)];
    %range=magicbox.ranges(thisvar,:);
    if range(1)-range(2)==0;return;end %avoids errors with constant variables.
    
    newminval=range(1)+((newminval-0.43)/0.3)*(range(2)-range(1));
    newmaxval=range(1)+((newmaxval-0.43)/0.3)*(range(2)-range(1));
end



%update text values

%make current value texts:


if ~any(strcmp(thistype,{'string','logical'}))
    minvaltext=strtrim(sprintf('%5.5g',newminval));
    maxvaltext=strtrim(sprintf('%5.5g',newmaxval));    
elseif strcmp(thistype,'string')
    minvaltext=handles.discretevalues{d}{a}{xcol(index)}{newminval};
    maxvaltext=handles.discretevalues{d}{a}{xcol(index)}{newmaxval};
else %logical
    if newminval
        minvaltext=handles.prefs.logicaltrue;
    else
        minvaltext=handles.prefs.logicalfalse;
    end
    
    if newmaxval
        maxvaltext=handles.prefs.logicaltrue;
    else
        maxvaltext=handles.prefs.logicalfalse;
    end
end

udata.view.lowfilters(thisvar)=newminval;
set(udata.view.minvaltexts(idx),'string',minvaltext,'color',[0 0 0]);

udata.view.highfilters(thisvar)=newmaxval;
set(udata.view.maxvaltexts(idx),'string',maxvaltext,'color',[0 0 0]);


set(handles.fakeax(ai),'userdata',udata);
guidata(handles.fig,handles);


%update on slide if desired:
if handles.prefs.alwaysupdate && ~handles.prefs.alwaysrasterize
    filterapplyfilter(get(src,'parent'),[]);
    
end

function pprofdone(fig,eventdata,src) %#ok<INUSL>
handles=guidata(fig);
set(handles.fig,'windowbuttonmotionfcn','')
set(handles.fig,'windowbuttonupfcn','')


filterapplyfilter(get(src,'parent'),[]);

