function boxselectline(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

ai=find(handles.allgraphs==src);

udata=get(handles.fakeax(ai),'userdata');

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.selection=rectangle('position',[xclick yclick eps eps],'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',src,'hittest','off','facecolor','none','clipping','on');
%maindata=findobj(handles.activegraph,'tag','main');
%set(maindata,'visible','off');

handles.temp.selected=findobj(src,'tag','selected');
handles.temp.main=findobj(src,'type','line','marker','none');
handles.temp.xdata=get(handles.temp.main(1),'xdata'); %all have the same xdata
set(handles.temp.selected,'visible','off');

handles.temp.isselected=false(size(handles.alldata{udata.view.dataset},1),1);

%maintain manual/auto sizing:
handles.temp.axesmode=get(src,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@ravesizeselection);
set(handles.fig,'WindowButtonUpFcn',@ravesizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

function ravesizeselection(src,eventdata) %#ok<INUSD>
handles=guidata(src);

ai=find(handles.allgraphs==gca);


% udata=get(handles.fakeax(handles.activeindex),'userdata');

%if in pointselect mode, dont allow sizing, just go straight to buttonupfcn.
maindata=findobj(gca,'type','line','marker','none');
if ~isempty(get(maindata(1),'buttondownfcn'))
    if strcmp(func2str(get(maindata(1),'buttondownfcn')),'pointselect')
        return
    end
end

finish=get(gca,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4]);
end
%determine which points are in this rectangle:

inpoints=handles.temp.xdata>pos1 & handles.temp.xdata<(pos1+pos3);

if ~any(inpoints)
    set(handles.temp.selected,'visible','off')
else
    for j=1:length(handles.temp.selected)
        ycol=get(handles.temp.selected(j),'userdata');
        thismain=findobj(handles.temp.main,'markersize',ycol);
        ydata=get(thismain,'ydata');
        xdata=get(thismain,'xdata');
        set(handles.temp.selected(j),'xdata',xdata(inpoints),'ydata',ydata(inpoints),'visible','on')%,'userdata',inpoints);
    end

end

handles.temp.isselected=inpoints;
guidata(src,handles);

%set(handles.temp.selection,'userdata',inpoints);


function ravesizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',[]);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
%set(handles.temp.main,'visible','on');


isselected=false(size(handles.alldata{udata.view.dataset},1),1);
isselected(handles.temp.isselected)=true;
handles.isselected{udata.view.dataset}{udata.view.analysis}=isselected;
delete(handles.temp.selection);

%store indices of selected points.
set(handles.fakeax(ai),'userdata',udata);
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',1);

