function pointselectscatter(src,ev)

handles=guidata(src);

if ~strcmp(handles.selectionmode,'point');return;end

%determine which point was clicked:
handles=guidata(src);

ai=find(handles.allgraphs==get(src,'parent'));

udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

handles.temp.selected=findobj(handles.allgraphs(ai),'tag','selected');

clicked=get(handles.allgraphs(ai),'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);

%convert xclick/yclick to pixels.
xdata=get(src,'xdata');
ydata=get(src,'ydata');
cdata=get(src,'cdata');
sdata=get(src,'sizedata');

inpoints=ravefindclosestpoint2D(xclick,yclick,src);

%ravefindclosestpoint2D does not return correct index since some points may be hidden... expand out for hidden points:

visiblepoints=find(handles.isvisible{d}{a});
selectedpoint=visiblepoints(inpoints);
realpoints=false(size(handles.isvisible{d}{a}));
realpoints(selectedpoint)=true;

%need to set all data properties so dimensions are correct.
set(handles.temp.selected,'xdata',xdata(inpoints),'ydata',ydata(inpoints),...
    'cdata',cdata(inpoints),'sizedata',sdata(inpoints),'visible','on','userdata',realpoints);
if udata.view.s==0 %isallonesize
    set(get(handles.temp.selected,'children'),'markersize',sqrt(udata.format.minmarkersize));
end

handles.isselected{udata.view.dataset}{udata.view.analysis}=get(handles.temp.selected,'userdata');

handles.lastd=d;
handles.lasta=a;


guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',1);

if handles.prefs.setxdialswhensingleselected
    handles.xdials{udata.view.dataset}{udata.view.analysis}=handles.alldata{udata.view.dataset}(realpoints,:);
    guidata(src,handles);
    raveupdateanalysis(src,[],'xdials',1);
end







