function raveupdatescatterisselected(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
getudata;
ai=handles.activeindex;


d=udata.view.dataset;
a=udata.view.analysis;


inpoints=handles.isselected{d}{a};
nothidden=find(handles.isvisible{d}{a});

inpoints=inpoints(nothidden); %#ok<FNDSB>

selectedhandles=findobj(handles.allgraphs(ai),'tag','selected');
maindata=findobj(handles.allgraphs(ai),'tag','main');

xdata=get(maindata,'xdata');
ydata=get(maindata,'ydata');
cdata=get(maindata,'cdata');
sdata=get(maindata,'sizedata');

if isempty(inpoints)
    set(selectedhandles,'visible','off')%,'userdata',false(size(handles.temp.xdata)))
else
    %need to set all data properties so dimensions are correct.
    set(selectedhandles,'xdata',xdata(inpoints),'ydata',ydata(inpoints),...
        'cdata',cdata(inpoints),'sizedata',sdata(inpoints),'visible','on')%,'userdata',inpoints);
    if udata.view.s==0 %isallonesize
        set(get(selectedhandles,'children'),'markersize',sqrt(udata.format.minmarkersize));
    end
    
end



%udpate colorbar:
if numel(inpoints)==1
    if udata.format.colorbar
        legdata=get(handles.fakerax(ai),'userdata');
        
        cbar=findobj(legdata,'tag','Colorbar');
        
        ylim=get(cbar,'ylim');
        clim=udata.view.clim;
        
        %determine current c value:
        thisvalue=raveevaluateregression(src,udata.view.dataset,udata.view.c,handles.xdials{udata.view.dataset}{udata.view.analysis});
        
        thiscoord=interp1(clim,ylim,thisvalue);
        
        %make triangle patch at this value:
        cvpatch=findobj(cbar,'tag','currentvalue');
        set(cvpatch,'ydata',[thiscoord-1.5 thiscoord+1.5 thiscoord]);
        cvtext=findobj(cbar,'tag','currentvaluetxt');
        pos=get(cvtext,'pos');
        set(cvtext,'pos',[pos(1) thiscoord],'string',sprintf('%5.5g',thisvalue));
    end
end





