function raveupdatescatter3Drowcolors(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
getudata;
ai=handles.activeindex;

%get data
x=handles.alldata{udata.view.dataset}(:,udata.view.x);
y=handles.alldata{udata.view.dataset}(:,udata.view.y);
z=handles.alldata{udata.view.dataset}(:,udata.view.z);

%maintain selection:
%isselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
%                     isselected=false(length(x),1);
%                     isselected(handles.isselected{udata.view.dataset}{udata.view.analysis})=true;
%
%maintain hidden points:
nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};

if udata.view.c~=0
    return
    
else
    if udata.format.ncolor
        c=handles.prefs.rowcolors(handles.rowcolors{udata.view.dataset}{udata.view.analysis})'+10*rand(length(x),1)-.5; %noisy colors
    else
        c=handles.prefs.rowcolors(handles.rowcolors{udata.view.dataset}{udata.view.analysis})'; %non-noisy colors cdata=0.5
    end
end

if udata.view.s~=0
    s=handles.alldata{d}(:,udata.view.s);
    isallonesize=0;
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    s=(((s-min(s))/(max(s)-min(s))).^2)*maxsize + minsize + rand(length(x),1)/100;
else
    s=ones(length(x),1);
    isallonesize=1;
end

h=findobj(handles.activegraph,'tag','main');
set(h,'xdata',x,'ydata',y,'zdata',z,'cdata',c,'sizedata',s)

minsize=udata.format.minmarkersize;
if isallonesize
    set(get(h,'children'),'markersize',sqrt(minsize));
else
    set(h,'sizedata',s);
end