function raveinitializebarcategorical(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
%make scatter graph with x=1st independent, y=1st response, c=none

d=1; %default data set index

iscategorical=find(ismember(handles.datatype{d},'discrete') | ismember(handles.datatype{d},'string'),1);
isnumerical = find(~ismember(handles.datatype{d},'string'),2);
if isnumerical(1)==iscategorical;isnumerical=isnumerical(2);end;

if isempty(iscategorical) || isempty(isnumerical)
    udata.view.x=0; %x axis (categorical)
    udata.view.y=0; %y axis (numerical)
    udata.view.z=0; %stack by (categorical)
    udata.view.c=0; %unused
    udata.view.s=0; %unused
else
    udata.view.x=iscategorical; %x axis (categorical)
    udata.view.y=isnumerical(1); %y axis (numerical)
    udata.view.z=0; %stack by (categorical) 0 = none.
    udata.view.c=0; %unused
    udata.view.s=0; %unused
end

udata.manage.israsterized=0;

%make viewtab info:
udata.view.analysis=1;
udata.view.dataset=1;
udata.view.constraints=0;
udata.view.response=0; %response check box value
udata.view.barwidth=1; %relative width of bars.
udata.view.normalize=0; %show percentages instead of counts;
udata.view.stack=1; %stack vertically instead of horizontally;
udata.view.aggregateby=1; %1=sum, 2=average



%make format tab info:
udata.format.bg=1; %index for background color;
udata.format.grid=1; %index for grid;
udata.format.facecolor=[.3 .6 1]; %bar face color
udata.format.edgecolor=[0 0 0];
udata.format.drawedge=1;
udata.format.orient='vertical'; %bar orientation
udata.format.nxlabelrows=0;

%make explre tab info:
udata.explore.option=1;
udata.explore.method=cell(0);


%set fakeax userdata (tab info)
set(handles.fakeax(handles.activeindex),'userdata',udata);

%make the graph
ravecreatebarcategorical(handles.fig,[]);