function raveinitializescatter(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
     %make scatter graph with x=1st independent, y=1st response, c=none
        
        d=1; %default data set index
        
        if ~all(handles.isresponse{d}==0)
            x=find((~handles.isconstant{d} & ~handles.isresponse{d}),1);
            y=find((~handles.isconstant{d} & handles.isresponse{d}),1);
            c=0;
            s=0;
        else
            x=find((~handles.isconstant{d}),1);
            y=find((~handles.isconstant{d}),1);
            c=0;
            s=0;
            
        end
        
        
        udata.manage.israsterized=0;
        
        %make viewtab info:
        udata.view.analysis=1;
        udata.view.dataset=1;
        udata.view.x=x;
        udata.view.y=y;
        udata.view.z=0;
        udata.view.c=c;
        udata.view.s=s;
        udata.view.response=0; %response check box value
        udata.view.exclude=0; %exclude constant check box value
        udata.view.constraints=0;
        
        %make format tab info:
        udata.format.bg=1; %index for background color;
        udata.format.grid=1; %index for grid;
        udata.format.marker='o'; % marker string
        udata.format.minmarkersize=16; %min marker size (pixels^2)
        udata.format.maxmarkersize=625; %max marker size (pixels^2)
        udata.format.markerfill=2; %marker fill style index.
        udata.format.mcmap=1; %marker colormap (index?)
        udata.format.linestyle='-'; %line style string
        udata.format.linesize=2; %line thickness;
        udata.format.mcheck=1; %marker check box value
        udata.format.lcheck=1; %line check box value
        udata.format.ncolor=0; %noisy colors check box value;
        udata.format.colorbar=0;
        udata.format.cbarhandle=0;
        udata.format.updatedials=1; %update xdials when a single point is clicked;
        udata.format.reversecolors=0;
        udata.format.nxlabelrows=0;
        
        %make explre tab info:
        udata.explore.option=1;
        udata.explore.responseprofiler=0;
        udata.explore.method=cell(0);
        
        
        %set fakeax userdata (tab info)
        set(handles.fakeax(handles.activeindex),'userdata',udata);
        
        %make the graph
        ravecreatescatter(handles.fig,[]);