function ravearrangeobjectsgoodness(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

if udata.view.graphs<5
    numax=[1 1];
    ymargin=20;
    xmargin=0;
else
    numax=[2 2];
    ymargin=80;
    xmargin=80;
end

rows=numax(1);
cols=numax(2);

pos = get(handles.activegraph,'Position');%+[30 30 -45 -30]; %shrink a little to fit tick labels. (now handled by raveresizeaxes)

width = (pos(3)-xmargin)/cols;
height = (pos(4)-ymargin-30)/rows;

ax=handles.subax{handles.activeindex};
fakeax=handles.subfakeax{handles.activeindex};
fakerax=handles.subfakerax{handles.activeindex};

xlabelz=findall(ax,'tag','xticklabel'); %use findall since handle visibility is off.
if pos(3)/cols<250
    set(xlabelz,'rotation',90,'horizontalalignment','right','verticalalignment','default')
else
    set(xlabelz,'rotation',0,'horizontalalignment','center','verticalalignment','top')
end

%set up grid of axes.
for r=rows:-1:1,
    for c=cols:-1:1,
        axPos = [pos(1)+(c-1)*(width+xmargin) pos(2)+(rows-r)*(height+ymargin) ...
            width height];
        set([ax(r,c) fakerax(r,c) fakeax(r,c)],'Position',axPos);
    end
end