function raveupdatetableallpoints(src,ev)
%create data for table based on udata.view



handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

unselectedrows=~handles.isselected{d}{a};
selectedrows=handles.isselected{d}{a};
hiddenrows=~handles.isvisible{d}{a};

showtheserows=false(size(unselectedrows));
if udata.view.showrows(1) 
    showtheserows(unselectedrows)=true;
end

if udata.view.showrows(2) 
    showtheserows(selectedrows)=true;
end

if udata.view.showrows(3) 
    showtheserows(hiddenrows)=true;
else 
    showtheserows(hiddenrows)=false;
end

allrows=find(showtheserows);


numrows=size(handles.alldata{d},1);
rownumbers=1:numrows;
%convert data into a cell array of strings:
rownumbers=num2cell(rownumbers);
for r=1:numrows
    rownumbers{r}=sprintf('%-6.0f',rownumbers{r});
end

rownumbers=rownumbers(showtheserows);
data=handles.alldata{d}(showtheserows,udata.view.x);


if udata.view.s>0
    sortcol=udata.view.s;
    if udata.view.sortascending
        [junk idx]=sort(handles.alldata{d}(showtheserows,sortcol),'ascend'); %#ok<ASGLU>
    else
        [junk idx]=sort(handles.alldata{d}(showtheserows,sortcol),'descend'); %#ok<ASGLU>
    end
    data=data(idx,:);
    rownumbers=rownumbers(idx);
    allrows=allrows(idx);
end

if ~isempty(data) && isfinite(udata.view.rowlimit) && udata.view.rowlimit>0 && udata.view.rowlimit<size(data,1)
    data=data(1:ceil(udata.view.rowlimit),:); 
    rownumbers=rownumbers(1:ceil(udata.view.rowlimit));
    allrows=allrows(1:ceil(udata.view.rowlimit));
end

udata.view.data=data;
udata.view.dataset=d;
udata.view.allrows=allrows;
udata.view.rownames=rownumbers;
udata.view.headerwidth=10+10*ceil(log10(numrows));

set(handles.fakeax(handles.activeindex),'userdata',udata)

ravecreatetableallpoints(src,ev);


