function raveupdatetableallpointsrowcolors(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
a=udata.view.analysis;

if ~udata.format.userowcolors;return;end


data=udata.view.data;
numrows=size(data,1);
rowheight=udata.view.rowheight;


%% make main table image:
rhimg=findobj(handles.subax{handles.activeindex},'tag','rowheaderimage');
rh=get(rhimg,'cdata');


cmap=get(handles.fig,'colormap');
rowcolors=cmap(handles.prefs.rowcolors,:);
for c=1:10
    theserows=udata.view.allrows(handles.rowcolors{d}{a}(udata.view.allrows)==c);
    if ~isempty(theserows)
        adders=repmat(0:rowheight-1,size(theserows,1),1);
        pixes=theserows(:).*rowheight-rowheight;
        pixes=bsxfun(@plus,pixes,adders);
        pixes=pixes(:)+1;
        rh(pixes,:,1)=rowcolors(c,1);
        rh(pixes,:,2)=rowcolors(c,2);
        rh(pixes,:,3)=rowcolors(c,3);
    end
end



%color row gridlines:
rowlines=[1 rowheight:rowheight:numrows*rowheight];
rh(rowlines,:,1)=udata.format.gridlinecolor(1);
rh(rowlines,:,2)=udata.format.gridlinecolor(2);
rh(rowlines,:,3)=udata.format.gridlinecolor(3);

set(rhimg,'cdata',rh);

