function raveupdatetableallpointvisiblerows(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
a=udata.view.analysis;

isselected=handles.isselected{d}{a};
isvisible=handles.isvisible{d}{a};

data=udata.view.data;
rowheight=udata.view.rowheight;
numrows=size(data,1);

%% make main table image:
timg=findobj(handles.fakeax(handles.activeindex),'tag','mainimage');
t=get(timg,'cdata');

if ~isempty(data)
    
    %unselected rows:
    t(:,:,1)=udata.format.unselectedcolor(1);
    t(:,:,2)=udata.format.unselectedcolor(1);
    t(:,:,3)=udata.format.unselectedcolor(1);

    %color according to row state:
    selectedrows=udata.view.allrows(isselected(udata.view.allrows));
    adders=repmat(0:rowheight-1,size(selectedrows,1),1);
    pixes=selectedrows(:).*rowheight-rowheight;
    pixes=bsxfun(@plus,pixes,adders);
    pixes=pixes(:)+1;
    t(pixes,:,1)=udata.format.selectedcolor(1);
    t(pixes,:,2)=udata.format.selectedcolor(2);
    t(pixes,:,3)=udata.format.selectedcolor(3);
    
    hiddenrows=udata.view.allrows(~isvisible(udata.view.allrows));
    adders=repmat(0:rowheight-1,size(hiddenrows,1),1);
    pixes=hiddenrows(:).*rowheight-rowheight;
    pixes=bsxfun(@plus,pixes,adders);
    pixes=pixes(:)+1;
    t(pixes,:,1)=udata.format.hiddencolor(1);
    t(pixes,:,2)=udata.format.hiddencolor(2);
    t(pixes,:,3)=udata.format.hiddencolor(3);
    
    %color horizontal grid lines:
    rowlines=[1 rowheight:rowheight:(rowheight*numrows)];
    t(rowlines,:,1)=udata.format.gridlinecolor(1);
    t(rowlines,:,2)=udata.format.gridlinecolor(2);
    t(rowlines,:,3)=udata.format.gridlinecolor(3);
    
    set(timg,'cdata',t);
end