function raveupdatevaluestablesinglepoint(src,ev)
%Only updates the displayed values of a single point table.
%Faster than recreating entire table.
%DOES NOT modify udata, only displays the data already stored in udata.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;


texthandles=udata.view.texthandles;

if ~isempty(texthandles)
    data=num2cell(udata.view.data);
    for r=1:numel(data)
        if ~strcmp(handles.datatype{d}{udata.view.y(r)},'string')
            data{r,1}=sprintf('%-12.5g',data{r,1});
        else
            data{r,1}=handles.discretevalues{d}{a}{udata.view.y(r)}{data{r,1}};
        end
    end
    set(texthandles,{'string'},data)
end


