function raveRowHeaderCallback(jsrc,jev,src) %#ok<INUSL>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

MouseEvent=jev;

if MouseEvent.getClickCount == 2 %double click
    %if this is a function, display it in the editor:
    handles=guidata(src);
    x=MouseEvent.getX();
    columnModel=handles.maintable.jtable.getColumnModel();
    c=columnModel.getColumnIndexAtX(x); %View Index
    thiscol=handles.maintable.jtable.convertColumnIndexToModel(c); %model index
    thiscol=thiscol+1; %convert to matlab index;
    if handles.isfunction{handles.maintable.d}(thiscol)
        edit(handles.funnames{handles.maintable.d}{thiscol});
    end
    
     
elseif MouseEvent.getButton > 1    %right click
    %this will eventually display a context menu
    
    handles=guidata(src);
   
    %determine where to put context menu:  
    xpos1=get(handles.maintable.handle,'position');
    xpos2=MouseEvent.getX;
    
    ypos1=get(handles.maintable.handle,'position');
    ypos2=MouseEvent.getY;
    ypos3=handles.maintable.jtable.getVisibleRect.getY();
    
    colHeader=handles.maintable.jtable.getTableHeader();
    ypos4=colHeader.getHeight();
    
   finalpos=[xpos1(1)+xpos2(1) ypos1(2)+ypos1(4)-ypos2+ypos3-ypos4]; 
   
   set(handles.contextmenus.maintablerowheader,'position',finalpos,'visible','on');
   set(0,'userdata',MouseEvent);

    
else %presumably single left click 
   %select this row
   handles=guidata(src);
   d=handles.maintable.d;
   jtable=handles.maintable.jtable;
    
   x=MouseEvent.getX();
   y=MouseEvent.getY();
   
   thisrow=jtable.rowAtPoint(java.awt.Point(x,y));
   
%    jtable.setColumnSelectionAllowed(true);
%    jtable.setRowSelectionAllowed(true);
   
   ncols=handles.maintable.models{d}.getColumnCount();
   
   mods=MouseEvent.getModifiers(); %binary weirdness.
   mods=fliplr(dec2bin(mods,64)); %no reason not to use 64 bits...
   mods=uint8(mods)-48;
      
   %NOBUTTON=0;
   %BUTTON1_MASK=16;
   %SHIFT_MASK=1;
   %CTRL_MASK=2;
   %ALT_MASK=8;
   %META_MASK=4;
   %BUTTON2_MASK=8;
   %BUTTON3_MASK=4;
   
   
   selectedCols=jtable.getSelectedColumns;
   selectedRows=jtable.getSelectedRows;
    
   if mods(2) %CTRL
       %if non-rows are selected, clear selection.
       if numel(selectedCols)<ncols
           jtable.clearSelection();
       end       
       
       %add this row to selection:
       
       if ~ismember(thisrow,selectedRows)
           jtable.addRowSelectionInterval(thisrow,thisrow);
           jtable.setColumnSelectionInterval(0,ncols-1);
       else
           jtable.removeRowSelectionInterval(thisrow,thisrow);
           jtable.setColumnSelectionInterval(0,ncols-1);
       end
       
   elseif mods(1) %SHIFT
       %if non-rows are selected, clear selection.
       if numel(selectedCols)<ncols
           jtable.clearSelection();
       end       
       
       if thisrow<min(selectedRows)
           jtable.addRowSelectionInterval(thisrow,min(selectedRows-1))
       elseif thisrow>max(selectedRows)
           jtable.addRowSelectionInterval(max(selectedRows+1),thisrow)
       end

       jtable.setColumnSelectionInterval(0,ncols-1); 
       
       
       
   else %presumably nothing
       try %gives error if you click and drag cursor out of bounds before releasing
       jtable.setRowSelectionInterval(thisrow,thisrow);
       jtable.setColumnSelectionInterval(0,ncols-1);
       end
       %}
   end
   
end