function ravecreatemaintable(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

%table dims:
left=30+315*handles.prefs.tabscale;
bottom=1;
height=handles.height-35;
width=handles.width-(30+315*handles.prefs.tabscale);
%new method:

% 
% [mtable,junk]=uitable('parent',handles.fig,'position',[left bottom width height]);
% jscroll=findjobj(mtable);
% h=jscroll.getComponents;
% viewport=h(1);
% a=viewport.getComponents;
% jtable=a(1); %com.mathworks.hg.peer.ui.UITablePeer 

originalLnF = javax.swing.UIManager.getLookAndFeel;  %class

if ~handles.prefs.dontchangemylaf
    try %#ok<TRYNC>
        newLnF = 'com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel';
  %      javax.swing.UIManager.setLookAndFeel(newLnF);
    end
end

data={'No Data Loaded'}; %the table data.
varnames={''};

dblArray=javaArray('java.lang.Object',size(data,1),size(data,2)); %the table data
dblRows=javaArray('java.lang.Integer',size(data,1),1); %row header numbers

tableData=java.lang.String('No Data Loaded');
varnames={''};
rowData=java.lang.Integer(1);


%make main table model, and put it in a table:
dmodel=javax.swing.table.DefaultTableModel(tableData,varnames);
jtable=javax.swing.JTable(dmodel);

%make row header model, and put it in a table:
rmodel=javax.swing.table.DefaultTableModel(rowData,{''});
rowHeader=javax.swing.JTable(rmodel);

%not sure what this does, but i guess it's important...
jtable.setSelectionModel(rowHeader.getSelectionModel());

%some formatting...
rowHeader.setBackground(java.awt.Color.lightGray);
rowHeader.setColumnSelectionAllowed(false);
rowHeader.setCellSelectionEnabled(false);

%make the header the appropriate width:
headerWidth=25;
rhHeight=rowHeader.getPreferredSize.height;
rowHeader.setPreferredSize(java.awt.Dimension(headerWidth,rhHeight))
rowHeader.setSize(java.awt.Dimension(headerWidth,rhHeight))

%hide the column header of the row header:
rowHeader.getTableHeader.setVisible(false);

%put the row header in a viewport.
jv=javax.swing.JViewport;
jv.setView(rowHeader);
jv.setPreferredSize(java.awt.Dimension(headerWidth,rhHeight));

%put the main table in a scroll pane, and append the row header:
jtable.setAutoResizeMode(jtable.AUTO_RESIZE_OFF);
jscroll=javax.swing.JScrollPane(jtable);
jscroll.setRowHeader(jv);
jscroll.setCorner(javax.swing.ScrollPaneConstants.UPPER_LEFT_CORNER, rowHeader.getTableHeader());

%place it all in your figure:
[jscroll mtable]=javacomponent(jscroll,[left bottom width height],handles.fig);

jtable=handle(jtable,'callbackproperties');

% [jtable mtable jscroll]=raveuitable(handles.fig,[left bottom width height]);
% if isempty(jscroll)
%     jscroll=findjobj(mtable);
% end

jtable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF); %no auto resize (show horizontal scroll)
g=handles.colors.maintable.grid;
jtable.setGridColor(java.awt.Color(g(1),g(2),g(3)));
jtable.setBackground(java.awt.Color(1,1,1));
% try %doesnt work for old tables
%     jtable.setNonContiguousCellSelection(false); %need to do this to allow setting cell selection
% end
jtable.setColumnSelectionAllowed(true);
jtable.setRowSelectionAllowed(true);

%save header renderer for future use:
% rowHeaderViewport=jscroll.getComponent(4);
% rowHeader=rowHeaderViewport.getComponent(0);
cm=rowHeader.getColumnModel;
c=cm.getColumn(0);
handles.maintable.defaultRowHeaderRenderer=c.getCellRenderer;

%fix blinking:

try
    set(jtable,'DoubleBuffered',1);
catch %#ok<CTCH>
    set(jtable,'DoubleBuffered','on');
end

try 
    set(jscroll,'DoubleBuffered',1);
catch %#ok<CTCH> 
    set(jscroll,'DoubleBuffered','on');
end

set(mtable,'backgroundcolor',[1 1 1]);
handles.maintable.handle=mtable;
handles.maintable.jtable=jtable;
handles.maintable.jscroll=jscroll;
guidata(handles.fig,handles);

%drawnow;
%javax.swing.UIManager.setLookAndFeel(originalLnF);



