function ravemaintabledeleterows(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

%which rows to delete?

rows=handles.maintable.jtable.getSelectedRows(); %view index

modelrows=rows;
for r=1:numel(rows)
   modelrows(r)=handles.maintable.jtable.getModel().modelIndex(rows(r)); 
end

modelrows=sort(modelrows,'descend'); %must delete from bottom to top.

%prompt for confirmation:

answer=questdlg('Are you sure you want to delete the selected rows? Warning: This action cannot be undone.','Delete selected rows?','No');

%do delete:
if strcmp(answer,'Yes')
    
    d=handles.maintable.d;
    
    %remove from table:
    %turn off tablechanged callback to avoid a loop:
    set(handles.maintable.models{d},'TableChangedCallback',[]);
    for r=modelrows' %needs to be a row vector for this syntax.
         handles.maintable.jtable.getModel().removeRow(r)
    end
    
    %turn table callback back on:
    set(handles.maintable.models{d},'TableChangedCallback',{@ravemaintablechangedcallback,handles.fig});
    
    %remove from matlab:
    modelrows=modelrows+1; %convert to matlab index.
    

    handles.alldata{d}(modelrows,:)=[];
    handles.alltext{d}(modelrows,:)=[];
    for a=1:numel(handles.analysisnames);
        handles.rowcolors{d}{a}(modelrows)=[];
        handles.isselected{d}{a}(modelrows)=[];
        handles.isvisible{d}{a}(modelrows)=[];
    end
end

%record action:
handles.datasetupdatespending{d}=union(handles.datasetupdatespending{d},'deleterows');

guidata(src,handles);