function varargout = managedatagui(varargin)
% MANAGEDATAGUI M-file for managedatagui.fig
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

% Last Modified by GUIDE v2.5 24-May-2011 14:33:45

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @managedatagui_OpeningFcn, ...
    'gui_OutputFcn',  @managedatagui_OutputFcn, ...
    'gui_LayoutFcn',  @managedatagui_LayoutFcn , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function h=managedatagui_LayoutFcn(varargin)
h=openfig('managedatagui.fig');

% --- Executes just before managedatagui is made visible.
function managedatagui_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<INUSL>

handles.managefig=hObject;

origin=get(0,'userdata');
thispos=get(hObject,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=origin(2)+origin(4)/2-thispos(4)/2;
set(hObject,'position',thispos);

%set theme:
load raveprefs

set(0,'userdata','cancel');

set(hObject,'color',raveprefs.colors.frame,'windowstyle','modal');
set(handles.uipanel1,'backgroundcolor',raveprefs.colors.tabbg);
set(handles.uipanel2,'backgroundcolor',raveprefs.colors.tabbg);


set(handles.titleaxes,'color','none','xcolor',raveprefs.colors.frame,...
    'ycolor',raveprefs.colors.frame,'zcolor',raveprefs.colors.frame);
set(handles.topframeaxes,'color','none','xcolor',raveprefs.colors.tabbg,...
    'ycolor',raveprefs.colors.tabbg,'zcolor',raveprefs.colors.tabbg);
set(handles.bottomframeaxes,'color','none','xcolor',raveprefs.colors.tabbg,...
    'ycolor',raveprefs.colors.tabbg,'zcolor',raveprefs.colors.tabbg);

%make titles
text(0,.4,'Manage Data Sets','parent',handles.titleaxes,'fontname',raveprefs.fonts.title,'fontsize',20*raveprefs.fonts.titlescale,...
    'color',raveprefs.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Create a New Data Set','parent',handles.topframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.2,'Manage Data Sets','parent',handles.bottomframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');

%display button icons
A=imread('browse.bmp');
set(handles.browsebutton,'cdata',A)

%get exising handles structure from maingui
handles.indata=guidata(gcbo); %gcbo = "manage data sets" button in maingui

%update listbox with current data sets
if isempty(handles.indata.datasetnames)
    set(handles.listbox1,'string','No Data Sets Loaded')
    set(handles.appendbutton,'enable','off')
    set(handles.replacebutton,'enable','off')
    set(handles.gpgpubutton,'enable','off')
    set(handles.defineunitsbutton,'enable','off')
    set(handles.deletebutton,'enable','off')
    set(handles.scalebutton,'enable','off')
    set(handles.changeunitsbutton,'enable','off')
    set(handles.definecolorsbutton,'enable','off')
    set(handles.decidebutton,'enable','off')
    set(handles.definetypebutton,'enable','off')
    set(handles.definetargetsbutton,'enable','off')
    set(handles.definebestcollist,'enable','off')
else
    set(handles.listbox1,'string',handles.indata.datasetnames,'value',1)
    set(handles.definebestcollist,'string',[cellstr('<None Specified>') handles.indata.allnames{1}],...
        'value',handles.indata.rankingcolumn{1}+1);
    set(handles.appendbutton,'enable','off')
    set(handles.replacebutton,'enable','off')
    set(handles.defineunitsbutton,'enable','off')
    set(handles.deletebutton,'enable','off')
    set(handles.scalebutton,'enable','off')
    set(handles.changeunitsbutton,'enable','off')
    
    
end

set(handles.gpgpubutton,'enable','off');


%disable create button until they choose a file
set(handles.createbutton,'enable','off')

% Choose default command line output for managedatagui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes managedatagui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = managedatagui_OutputFcn(hObject, eventdata, handles) %#ok<INUSL>
% Get default command line output from handles structure
varargout{1} = handles.output;

%%
%
%
%                     MAKE A NEW DATA SET
%
%
%%

function sourcefiletext_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
%no callback, just shows a value.

% --- Executes during object creation, after setting all properties.
function sourcefiletext_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in browsebutton.
function browsebutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
[name,path]=uigetfile({'*.txt;*.csv;*.xls;*.xlsx','Data Files (*.txt, *.csv, *.xls, *.xlsx)';'*.*','All Files (*.*)'},'Choose data file to load:');

if name==0
    set(handles.sourcefiletext,'string','');
    uicontrol(handles.sourcefiletext)
else
    set(handles.sourcefiletext,'string',fullfile(path,name));
    set(handles.newnametext,'string',name(1:end-4));
    set(handles.createbutton,'enable','on');
    uicontrol(handles.createbutton);
end




guidata(hObject,handles);

function newnametext_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% --- Executes during object creation, after setting all properties.

txt=get(hObject,'string');
if ~isempty(txt)
    set(handles.createbutton,'enable','on');
end


function newnametext_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in createbutton.
function createbutton_Callback(hObject, eventdata, handles) %#ok<INUSL>

%update uicontrols in this gui to reflect valid data set

datasetnames=handles.indata.datasetnames;
datasetnames{end+1}=get(handles.newnametext,'string');


set(handles.appendbutton,'enable','on')
set(handles.replacebutton,'enable','on')
set(handles.gpgpubutton,'enable','off')
set(handles.defineunitsbutton,'enable','on')
%set(handles.excludebutton,'enable','on')
set(handles.deletebutton,'enable','on')
set(handles.scalebutton,'enable','on')
set(handles.changeunitsbutton,'enable','on')
set(handles.definecolorsbutton,'enable','on')
set(handles.definetypebutton,'enable','on')
set(handles.definetargetsbutton,'enable','on')

%disable buttons that dont work yet:
set(handles.appendbutton,'enable','off')
set(handles.replacebutton,'enable','off')
set(handles.defineunitsbutton,'enable','off')
set(handles.deletebutton,'enable','off')
set(handles.scalebutton,'enable','off')
set(handles.changeunitsbutton,'enable','off')

%update number of data sets:
handles.D=numel(handles.indata.alldata)+1;

%read in data:
infile=get(handles.sourcefiletext,'String');

if isempty(infile)
    infile='-pastespecial';
end

in=importdata(infile);


if strcmp(infile(end-2:end),'xls')
    
    try
        sheetname=fieldnames(in.data);
    catch %#ok<CTCH>
        sheetname='';
    end
    
    
    if ~isempty(sheetname)
        in.data=in.data.(sheetname{1});
        
        if isfield(in,'colheaders')
            in.colheaders=in.colheaders.(sheetname{1});
            in.textdata=in.textdata.(sheetname{1})(:,:);
        else
            in.colheaders=in.textdata.(sheetname{1})(1,:);
            in.textdata=in.textdata.(sheetname{1})(2:end,:);
        end
    else
       % in.data=in.data;
        
        if isfield(in,'colheaders')
           % in.colheaders=in.colheaders;
           % in.textdata=in.textdata(:,:);
        else
            in.colheaders=in.textdata(1,:);
            in.textdata=in.textdata(2:end,:);
        end
        
    end
    
    varnames=in.colheaders;
else
    varnames=in.textdata(1,:);
    
end


for v=1:numel(in.textdata);
   if strcmp(in.textdata{v},'NaN')
       in.textdata{v}='';
   end
end




%check for textvars:
istext=false(1,size(in.textdata,2));
thinktext=istext; %variables matlab *thinks* are text
if size(in.textdata,1)>1;
    for g=1:size(in.textdata,2);
        
        if any(~cellfun(@isempty,in.textdata(2:end,g)))
            thinktext(g)=true;
%             if isnan(str2double(texttest{g}))
%                 istext(g)=true;
%             end
            
        end
    end
end

numericcols=~thinktext;
istext=thinktext;

%remove columns of in.data that are ALL nans.
loseit=false(1,size(in.data,2));
for g=1:size(in.data,2)
    if all(isnan(in.data(:,g)))
        loseit(g)=true;
    end
end

in.data=in.data(:,~loseit);



try
    
   % if ~strcmp(infile(end-2:end),'xls')
        data=nan(size(in.data,1),size(in.textdata,2));
        data(:,numericcols)=in.data;
   % else
   %     data=in.data;
   %end

    
catch %#ok<CTCH>
    errordlg('Something went wrong. Make sure number of data columns matches number of column headers.')
    return
end

%fix columns matlab thought were text but are actually numbers:
% screwups=find(thinktext & ~istext);
% 
% for w=1:numel(screwups);
%     data(:,screwups(w))=str2num(char(in.textdata{2:end,screwups(w)})); %#ok<ST2NM>
% end


numrows=size(data,1);
numvars=size(data,2);

if any(istext)
    textdata=in.textdata(2:end,:);
else
    textdata=cell(numrows,numvars);
end

discretevalues=cell(1,numvars);
%convert text values to numerical indexes:
for j=find(istext)
    discretevalues{j}=unique(textdata(:,j));
    for h=1:numel(discretevalues{j});
        isthisvalue=strcmp(discretevalues{j}{h},textdata(:,j));
        data(isthisvalue,j)=h;
    end
    
    for h=1:numel(discretevalues{j})
        discretevalues{j}=strtrim(discretevalues{j});
    end
    
end


%check for logical variables:

logicalz={'yes';'no';'true';'false';'on';'off'}; %#ok<NASGU>

islogical=false(numvars);
for j=1:numvars %for each variable:
    youneeks=unique(data(:,j));
    if numel(youneeks)==2
        if youneeks(1)==0 && youneeks(2)==1
            islogical(j)=true;
            discretevalues{j}=[0 1];
        end
    end
end






%% store results:
numa=numel(handles.indata.analysisnames);
mapname=handles.indata.prefs.defaultvariablecolors;
newcolorz=getvariablecolors(numvars,mapname);

%format/initialize data for output to main gui:
handles.indata.alldata{handles.D}=data;
handles.indata.backupdata{handles.D}=data;
handles.indata.alltext{handles.D}=textdata;
handles.indata.allnames{handles.D}=varnames;
handles.indata.variablecolors{handles.D}=newcolorz;
handles.indata.isresponse{handles.D}=false(1,numvars);
handles.indata.allunits{handles.D}=cell(1,numvars);
handles.indata.isvalid{handles.D}=true(size(data));
handles.indata.isincluded{handles.D}=true(1,numvars);
handles.indata.isdecided{handles.D}=false(1,numvars);
handles.indata.datasetnames{handles.D}=get(handles.newnametext,'string');
handles.indata.isconstant{handles.D}=false(1,numvars);  %<--- superceded by datatype, but i'll keep it in cause it shows up in a lot of places.
handles.indata.isfunction{handles.D}=false(1,numvars);
handles.indata.funclass{handles.D}=cell(1,numvars);
[handles.indata.funclass{handles.D}{:}]=deal('independent');
handles.indata.funnames{handles.D}=cell(1,numvars); %names of regressions for function columns.
handles.indata.funvars{handles.D}=num2cell(1:numvars); %variables in regressions for function columns.
handles.indata.nargout{handles.D}=zeros(1,numvars); %index of which output of its function this response is.
handles.indata.datatype{handles.D}=cell(1,numvars);
[handles.indata.datatype{handles.D}{:}]=deal('continuous');%constant values are replaced below.
handles.indata.targetvalues{handles.D}=zeros(1,numvars);
handles.indata.preferences{handles.D}=zeros(1,numvars);
handles.indata.normalizepreferences{handles.D}=true;
handles.indata.isobjective{handles.D}=false(1,numvars);
handles.indata.rankingcolumn{handles.D}=0;
handles.indata.datasetupdatespending{handles.D}=cell(0);
handles.indata.analysisupdatespending{handles.D}=cell(numa,1);
handles.indata.tablemodelupdatespending{handles.D}=cell(0);
handles.indata.maintable.colwidths{handles.D}=handles.indata.prefs.colwidth*ones(1,numvars);

%analysis variables:
handles.indata.xdials{handles.D}=cell(numa,1);
handles.indata.minlimit{handles.D}=cell(numa,1);
handles.indata.maxlimit{handles.D}=cell(numa,1);
handles.indata.discretevalues{handles.D}=cell(numa,1);
handles.indata.rowcolors{handles.D}=cell(numa,1);
handles.indata.ineqconstraints{handles.D}=cell(numa,1);
handles.indata.isselected{handles.D}=cell(numa,1);
handles.indata.isvisible{handles.D}=cell(numa,1);
handles.indata.constrainthandles{handles.D}=cell(numa,1);
handles.indata.constrainttext{handles.D}=cell(numa,1);
handles.indata.constrainttype{handles.D}=cell(numa,1);
handles.indata.constraintvalues{handles.D}=cell(numa,1);
handles.indata.constraintadders{handles.D}=cell(numa,1);
handles.indata.constraintscalers{handles.D}=cell(numa,1);
handles.indata.constraintvars{handles.D}=cell(numa,1);
handles.indata.constraintcolors{handles.D}=cell(numa,1);

[handles.indata.xdials{handles.D}{:}]=deal(mean(data));
[handles.indata.minlimit{handles.D}{:}]=deal(min(data));
[handles.indata.maxlimit{handles.D}{:}]=deal(max(data));
[handles.indata.discretevalues{handles.D}{:}]=discretevalues; %this will contain all allowable values of non-continuous variables
[handles.indata.rowcolors{handles.D}{:}]=deal(ones(numrows,1)*handles.indata.prefs.defaultrowcolor);
[handles.indata.isselected{handles.D}{:}]=deal(false(numrows,1));
[handles.indata.isvisible{handles.D}{:}]=deal(true(numrows,1));
[handles.indata.constrainthandles{handles.D}{:}]=deal(cell(0)); %function handles must be stored in a cell
[handles.indata.constrainttext{handles.D}{:}]=deal(cell(0));
[handles.indata.constrainttype{handles.D}{:}]=deal(cell(0));
[handles.indata.constraintvalues{handles.D}{:}]=deal(cell(0));
[handles.indata.constraintadders{handles.D}{:}]=deal([]);
[handles.indata.constraintscalers{handles.D}{:}]=deal([]);
[handles.indata.constraintvars{handles.D}{:}]=deal(cell(0));
[handles.indata.constraintcolors{handles.D}{:}]=deal(cell(0));

%check for isconstant:
for c=1:numvars
    
    handles.indata.funvars{handles.D}{c}=c; %independent varibles are their own funvar.
    
    if numel(unique(data(:,c)))==1
        handles.indata.isconstant{handles.D}(c)=true;
        handles.indata.datatype{handles.D}{c}='constant';
    elseif istext(c)
        handles.indata.datatype{handles.D}{c}='string';
        [handles.indata.xdials{handles.D}{:}(c)]=deal(1);
    elseif islogical(c)
        handles.indata.datatype{handles.D}{c}='logical';
        [handles.indata.xdials{handles.D}{:}(c)]=deal(0);
    end
end


%check how many columns it has:
if size(data,2)==1;
    warndlg('This data set only has one variable. I can''t really do much with this but make a histogram. Attempting to do anything else will probably cause errors.')
end



%% process metadata:
[pathstr, name, ext] = fileparts(infile);  %#ok<NASGU>
ravefunctions=which(fullfile(pathstr,[name '.rvefun']));
ravefeasiblevalues=which(fullfile(pathstr,[name '.rveval'])); %includes min/max ranges for responses.
raveconstraints=which(fullfile(pathstr,[name '.rvecon']));
ravedials=which(fullfile(pathstr,[name '.rvecur']));
ravetargets=which(fullfile(pathstr,[name '.rveopt'])); %targets + preferences + isobjective
ravecolors=which(fullfile(pathstr,[name '.rvecol'])); %variable colors
raverowstate=which(fullfile(pathstr,[name '.rverow'])); %row colors + visibility + issselected
ravepoi=which(fullfile(pathstr,[name '.rvepoi'])); %points of interest


if ~isempty(ravefunctions) && get(handles.metadatacheck,'value')
    [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,ravefunctions);
    if ~success;return;end
end

if ~isempty(ravefeasiblevalues) && get(handles.metadatacheck,'value')
    [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,ravefeasiblevalues);
end

if ~isempty(raveconstraints) && get(handles.metadatacheck,'value')
    [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,raveconstraints);
end

if ~isempty(ravedials) && get(handles.metadatacheck,'value')
   [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,ravedials);
end

if ~isempty(ravetargets) && get(handles.metadatacheck,'value')
    [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,ravetargets);
end

if ~isempty(ravecolors) && get(handles.metadatacheck,'value')
    [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,ravecolors);
end

if ~isempty(raverowstate) && get(handles.metadatacheck,'value')
    [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,raverowstate);
end

if ~isempty(ravepoi) && get(handles.metadatacheck,'value')
    [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,ravepoi);
end


%add this dataset to the list:
set(handles.listbox1,'string',datasetnames)

%clear creation data:
set(handles.newnametext,'string','')
set(handles.sourcefiletext,'string','')
set(handles.createbutton,'enable','off')
uicontrol(handles.donebutton)

pause(0.1); %attempt to avoid error
guidata(hObject,handles);

%create tableModel:
[model,rhmodel]=ravecreatemaintablemodel(hObject,[],handles.D,1);
handles.indata.maintable.models{handles.D}=model;
handles.indata.maintable.rhmodels{handles.D}=rhmodel;
handles.indata.maintable.d=handles.D;
handles.indata.maintable.a=1;
handles.indata.maintable.x{handles.D}=1:numvars;

guidata(hObject,handles);



%%
%
%
%                             EDIT EXISTING DATA SET
%
%
%
%%

% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
%does nothing, just returns a value;


set(handles.definebestcollist,'string',[cellstr('<None Specified>') handles.indata.allnames{get(src,'value')}],'value',handles.indata.rankingcolumn{get(src,'value')}+1);




function listbox1_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in appendbutton.
function appendbutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% --- Executes on button press in replacebutton.
function replacebutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% --- Executes on button press in gpgpubutton.
function gpgpubutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>

% --- Executes on button press in excludebutton.
function excludebutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
hhh=raveexcludecolumnsgui;
uiwait(hhh)
%collect results
handles.indata.isincluded{get(handles.listbox1,'value')}=get(0,'userdata');
set(0,'userdata',[]);

guidata(hObject,handles);


function defineunitsbutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
function deletebutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
function scalebutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
function changeunitsbutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>


% --- Executes on button press in definecolorsbutton.
function definecolorsbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>

%open define colors gui:
hhh=ravedefinevariablecolors(hObject,[]);
uiwait(hhh)

%collect results
newcolorz=get(0,'userdata');
if ~isempty(newcolorz)
    handles.indata.variablecolors=newcolorz;
end
set(0,'userdata',[]);

guidata(hObject,handles);


%%
%
%
%                       DONE BUTTONS
%
%
%
%%

% --- Executes on button press in donebutton.
function donebutton_Callback(hObject, eventdata, handles) %#ok<INUSL>

unprocessed=get(handles.sourcefiletext,'String');


if ~isempty(unprocessed) %check if they forgot to hit "create data set"
    answer=questdlg('You selected a file but did not create a data set from it. Create this data set now?',...
        'Create data set');
    if strcmp(answer,'Yes')
        createbutton_Callback(hObject,[], handles)
    end
    handles=guidata(hObject);
end

set(0,'userdata',handles.indata)
close(handles.managefig);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in stopbutton.
function stopbutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
keyboard;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in deleterowsbutton.
function deleterowsbutton_Callback(hObject, eventdata, handles)
% hObject    handle to deleterowsbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function definetypebutton_Callback(hObject, eventdata, handles)

%open definerolesgui
handles=guidata(hObject);
d=get(handles.listbox1,'value');

set(0,'userdata',get(handles.indata.fig,'position'));

hhh=ravedefinetypesgui;
uiwait(hhh)
%collect results

newdata=get(0,'userdata');
if ~isstruct(newdata);return;end

handles.indata.isresponse{d}=newdata.isresponse{d};
handles.indata.datatype{d}=newdata.datatype{d};
handles.indata.discretevalues{d}=newdata.discretevalues{d};
handles.indata.isconstant{d}=newdata.isconstant{d};
handles.indata.minlimit{d}=newdata.minlimit{d};
handles.indata.maxlimit{d}=newdata.maxlimit{d};
handles.indata.xdials{d}=newdata.xdials{d};

%handles.indata.isresponse{d}=0;
set(0,'userdata',[]);

guidata(hObject,handles);




% --- Executes on button press in definetargetsbutton.
function definetargetsbutton_Callback(hObject, eventdata, handles)
% hObject    handle to definetargetsbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

src=hObject;


%datasetmenu=handles.datasetlist;
%analysismenu=findobj(handles.tabobjects,'tag','analysismenu');

d=get(handles.listbox1,'value');
%a=get(analysismenu,'value');


hhh=ravedefinetargetsgui(src,[]);
uiwait(hhh)

newranges=get(0,'userdata');
if isempty(newranges);return;end

%fullranges=zeros(numel(handles.indata.allnames{d}),1);
%fullranges(logical(handles.indata.isresponse{d}))=newranges;
fullranges=newranges;

handles.indata.targetvalues{d}=fullranges;

guidata(hObject,handles);
set(0,'userdata',[]);


% --- Executes on button press in definebestcollist.
function definebestcollist_Callback(hObject, eventdata, handles)
% hObject    handle to definebestcollist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


d=get(handles.listbox1,'value');

handles.indata.rankingcolumn{d}=get(hObject,'value')-1;

guidata(hObject,handles);

% --- Executes on button press in metadatacheck.
function metadatacheck_Callback(hObject, eventdata, handles)
% hObject    handle to metadatacheck (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of metadatacheck




% --- Executes on button press in decidebutton.
function decidebutton_Callback(hObject, eventdata, handles)
% hObject    handle to decidebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

msgbox('This feature is not yet implemented in this GUI, however, you can decide variables by right clicking their column header in the data table and checking "Decided."','Coming Soon','help')
