function newindex=ravechoosecolormapcolor(src,ev,oldindex)
%a color chooser for when the chosen color must be an indexed color. 
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);

thecolors=get(handles.fig,'colormap');

set(0,'userdata',oldindex);

uicontrol(handles.dummyobj)

screensize=get(handles.fig,'position');

askbox=figure('units','pixels','position',[screensize(1)+screensize(3)/2-215 screensize(2)+screensize(4)/2-193+40 430 326],...
    'numbertitle','off','menubar','none','name','Select a Color','color',handles.colors.frame,...
    'resize','off','windowstyle','modal','userdata',oldindex);

 uicontrol('style','pushbutton','string','Ok','parent',askbox,'units','pixels',...
     'position',[295 15 100 30],'callback',@colorpopup_callback,'fontsize',12);
  uicontrol('style','pushbutton','string','Cancel','parent',askbox,'units','pixels',...
     'position',[185 15 100 30],'callback',@colorpopup_callback,'fontsize',12);

index=floor(linspace(1,128,10));


for c=1:15
    fullindex=index+128*(c-1);
    for r=1:10
        uicontrol('units','pixels','position',[15+24*c 360-24*r-60 20 20],...
                   'backgroundcolor',thecolors(fullindex(r),:),'userdata',fullindex(r),...
                   'callback','set(get(gcbo,''parent''),''userdata'',get(gcbo,''userdata''))');

    end
end

guidata(askbox,handles);


uiwait(askbox);

newindex=get(0,'userdata');
set(0,'userdata','');



function colorpopup_callback(src,ev)

askbox=get(src,'parent');

if strcmp(get(src,'string'),'Ok')
    set(0,'userdata',get(askbox,'userdata'))
end

delete(askbox);





