function ravedefinecoordinates(src,ev)
%functions to define coordinate systems for overlay plots.
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);

%get starting point:
clicked=get(handles.mainaxes,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

set(handles.fig,'WindowButtonMotionFcn',@ravemovecoordgrabber);
set(handles.fig,'WindowButtonUpFcn',@ravemovecoorddone);
set(handles.fig,'windowbuttondownfcn',[]);

set(handles.infobar,'string','To move without resizing, ctrl+click graph and drag to desired location.');
%NOTE: MOVING WITHOUT RESIZING IS DONE BY RAVESELECTGRAPH function.


guidata(src,handles);

%get current position of this grabber:
%grabpos=[get(src,'xdata') get(src,'ydata')];


function ravemovecoordgrabber(src,eventdata)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

set(handles.infobar,'string','...click "Define Coordinate System" button when finished.');
%NOTE: MOVING WITHOUT RESIZING IS DONE BY RAVESELECTGRAPH function.
finish=get(handles.activegraph,'currentpoint');

endx=finish(1,1,1);
endy=finish(1,2,1);

switch get(gco,'tag') %grabber order: [SW NW NE SE];
    case 'NE'
        %enforce minimum graph size:
        if endx<get(udata.view.grabbers(2),'xdata')+10
            endx=get(udata.view.grabbers(2),'xdata')+10;
        end

        if endy>get(udata.view.grabbers(4),'ydata')+9
            endy=get(udata.view.grabbers(4),'ydata')+9;
        end

        set(gco,'xdata',endx-3,'ydata',endy-2)
%         set(udata.view.grabbers(2),'ydata',endy-2)
%         set(udata.view.grabbers(4),'xdata',endx-3)

    case 'SE'
        %enforce minimum graph size:
        if endx<get(udata.view.grabbers(1),'xdata')+10
            endx=get(udata.view.grabbers(1),'xdata')+10;
        end

        if endy<get(udata.view.grabbers(3),'ydata')-10
            endy=get(udata.view.grabbers(3),'ydata')-10;
        end

        set(gco,'xdata',endx-3,'ydata',endy+3)
%         set(udata.view.grabbers(1),'ydata',endy+3)
%         set(udata.view.grabbers(3),'xdata',endx-3)

    case 'NW'
        %enforce minimum graph size:
        if endx>get(udata.view.grabbers(3),'xdata')-9
            endx=get(udata.view.grabbers(3),'xdata')-9;
        end

        if endy>get(udata.view.grabbers(1),'ydata')+9
            endy=get(udata.view.grabbers(1),'ydata')+9;
        end

        set(gco,'xdata',endx+2,'ydata',endy-2)
%         set(udata.view.grabbers(3),'ydata',endy-2)
%         set(udata.view.grabbers(1),'xdata',endx+2)
    case 'SW'
        %enforce minimum graph size:
        if endx>get(udata.view.grabbers(4),'xdata')-9
            endx=get(udata.view.grabbers(4),'xdata')-9;
        end

        if endy<get(udata.view.grabbers(2),'ydata')-10
            endy=get(udata.view.grabbers(2),'ydata')-10;
        end
        set(gco,'xdata',endx+2,'ydata',endy+3)
%         set(udata.view.grabbers(4),'ydata',endy+3)
%         set(udata.view.grabbers(2),'xdata',endx+2)
end



%Grabber order:
%SW NW NE SE

set(udata.view.limits,'xdata',[get(udata.view.grabbers(1),'xdata')+4 get(udata.view.grabbers(2),'xdata')+4 get(udata.view.grabbers(3),'xdata')-3 get(udata.view.grabbers(4),'xdata')-4])
set(udata.view.limits,'ydata',[get(udata.view.grabbers(1),'ydata')-4 get(udata.view.grabbers(2),'ydata')+3 get(udata.view.grabbers(3),'ydata')+3 get(udata.view.grabbers(4),'ydata')-4])

function ravemovecoorddone(src,eventdata)
handles=guidata(src);
set(handles.fig,'windowbuttonmotionfcn','');
set(handles.fig,'windowbuttonupfcn','');

set(handles.infobar,'string','Drag the corners of the green rectangle to known positions in the graph...');
