function ravemakecontextmenus(src,ev)
%this function defines the entries in all context menus used by rave.
%(though you could define them elsewhere if you'd like.)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);

%main table column header:
     menu=uicontextmenu('parent',handles.fig);
     uimenu(menu,'Label','Sort Ascending','callback',{@ravemaintablesort,'ascending','clear'});
     uimenu(menu,'Label','Sort Descending','callback',{@ravemaintablesort,'descending','clear'});
     %uimenu(menu,'Label','Sort Best to Worst','callback',{@ravemaintablesort,'rank','clear'});
     uimenu(menu,'Label','Sub-Sort Ascending','callback',{@ravemaintablesort,'ascending','noclear'});
     uimenu(menu,'Label','Sub-Sort Descending','callback',{@ravemaintablesort,'descending','noclear'});
     uimenu(menu,'Label','Clear Sorting','callback',{@ravemaintablesort,'clear','clear'});
     uimenu(menu,'Label','Copy','separator','on','callback',@ravemaintablecopy);
     uimenu(menu,'Label','Paste','callback',@ravemaintablepaste,'enable','off');
     uimenu(menu,'Label','Resample...','callback',@ravemaintableresample,'enable','off');
     uimenu(menu,'Label','Decided','separator','on','callback',@ravemaintabledecidecolumn,'enable','on');
     uimenu(menu,'Label','Quick Graph','separator','on','enable','off');
     handles.contextmenus.maintablecolumnheader=menu;

%main table row header:
     menu=uicontextmenu('parent',handles.fig);
     uimenu(menu,'Label','Copy','callback',@ravemaintablecopy);
     uimenu(menu,'Label','Paste','callback',@ravemaintablepaste,'enable','off');
     uimenu(menu,'Label','Delete Rows','separator','on','callback',@ravemaintabledeleterows);
     uimenu(menu,'Label','Add Rows...','callback',@ravemaintableaddrows,'enable','off');
     uimenu(menu,'Label','Hide/Unhide','separator','on','callback',@ravemaintablehideunhide);
     uimenu(menu,'Label','Row Color','enable','off');
     uimenu(menu,'Label','Make New Data Set...','separator','on','callback',@ravemaintablemakenewdataset,'enable','off');
     handles.contextmenus.maintablerowheader=menu;     
     

%main table body:
     menu=uicontextmenu('parent',handles.fig);
     uimenu(menu,'Label','Copy','callback',@ravemaintablecopy);
     uimenu(menu,'Label','Paste','callback',@ravemaintablepaste,'enable','off');
     uimenu(menu,'Label','Make New Data Set...','separator','on','callback',@ravemaintablemakenewdataset,'enable','off');
     handles.contextmenus.maintable=menu;

     
guidata(handles.fig,handles);
     