function ravemodelnn(src,ev)
%Create a neural network with rave. Requires nnet toolbox.
%
%newff(P,T,[S1 S2...S(N-l)],{TF1 TF2...TFNl}, BTF,BLF,PF,IPF,OPF,DDF) takes several arguments:
% P=	R x Q1 matrix of Q1 sample R-element input vectors
% T=	SN x Q2 matrix of Q2 sample SN-element target vectors
% Si=	Size of ith layer, for N-1 layers, default = [ ]. (Output layer size SN is determined from T.)
% TFi=	Transfer function of ith layer. (Default = 'tansig' for
% hidden layers and 'purelin' for output layer.)
% BTF=	Backpropagation network training function (default = 'trainlm')
% BLF=	Backpropagation weight/bias learning function (default = 'learngdm')
% PF=	Performance function. (Default = 'mse')
% IPF=	Row cell array of input processing functions. (Default = {'fixunknowns','removeconstantrows','mapminmax'})
% OPF=	Row cell array of output processing functions. (Default = {'removeconstantrows','mapminmax'})
% DDF=	Data divison function (default = 'dividerand')
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

%coming soon