function ravemovetable(src,ev) %#ok<INUSD>
%move/resize tables.
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);

%get starting point:
clicked=get(handles.mainaxes,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

set(handles.infobar,'string','To move without resizing, ctrl+click graph and drag to desired location.');
%NOTE: MOVING WITHOUT RESIZING IS DONE BY RAVESELECTGRAPH function.

set(handles.fig,'WindowButtonMotionFcn',@ravemovegrabber);
set(handles.fig,'WindowButtonUpFcn',@ravemovetabledone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

%get current position of this grabber:
%grabpos=[get(src,'xdata') get(src,'ydata')];


function ravemovegrabber(src,eventdata)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');


finish=get(handles.mainaxes,'currentpoint');

endx=finish(1,1,1);
endy=finish(1,2,1);

if handles.prefs.snaptogrid
    endx=handles.snapsize*round(endx/handles.snapsize);
    endy=handles.snapsize*round(endy/handles.snapsize);
end
%{
switch get(gco,'tag') %grabber order: [SW NW NE SE];
    case 'NE'
        %enforce minimum graph size:
        if endx<get(handles.grabbers{handles.activeindex}(1),'xdata')+198
            endx=get(handles.grabbers{handles.activeindex}(1),'xdata')+198;
        end

        if endy<get(handles.grabbers{handles.activeindex}(1),'ydata')+197
            endy=get(handles.grabbers{handles.activeindex}(1),'ydata')+197;
        end

        set(gco,'xdata',endx-3,'ydata',endy-2)
        set(handles.grabbers{handles.activeindex}(2),'ydata',endy-2)
        set(handles.grabbers{handles.activeindex}(4),'xdata',endx-3)

    case 'SE'
        %enforce minimum graph size:
        if endx<get(handles.grabbers{handles.activeindex}(1),'xdata')+udata.view.headerwidth+25+46
            endx=get(handles.grabbers{handles.activeindex}(1),'xdata')+udata.view.headerwidth+25+46;
        end

        if endy>get(handles.grabbers{handles.activeindex}(2),'ydata')-198
            endy=get(handles.grabbers{handles.activeindex}(2),'ydata')-198;
        end

        set(gco,'xdata',endx-3,'ydata',endy+3)
        set(handles.grabbers{handles.activeindex}(1),'ydata',endy+3)
        set(handles.grabbers{handles.activeindex}(3),'xdata',endx-3)

    case 'NW'
        %enforce minimum graph size:
        if endx>get(handles.grabbers{handles.activeindex}(3),'xdata')-197
            endx=get(handles.grabbers{handles.activeindex}(3),'xdata')-197;
        end

        if endy<get(handles.grabbers{handles.activeindex}(1),'ydata')+197
            endy=get(handles.grabbers{handles.activeindex}(1),'ydata')+197;
        end

        set(gco,'xdata',endx+2,'ydata',endy-2)
        set(handles.grabbers{handles.activeindex}(3),'ydata',endy-2)
        set(handles.grabbers{handles.activeindex}(1),'xdata',endx+2)
    case 'SW'
        %enforce minimum graph size:
        if endx>get(handles.grabbers{handles.activeindex}(3),'xdata')-197
            endx=get(handles.grabbers{handles.activeindex}(3),'xdata')-197;
        end

        if endy>get(handles.grabbers{handles.activeindex}(3),'ydata')-198
            endy=get(handles.grabbers{handles.activeindex}(3),'ydata')-198;
        end
        set(gco,'xdata',endx+2,'ydata',endy+3)
        set(handles.grabbers{handles.activeindex}(4),'ydata',endy+3)
        set(handles.grabbers{handles.activeindex}(2),'xdata',endx+2)
end

%}


minheight=handles.graphinfo.(handles.activetype).minheight;
minwidth=handles.graphinfo.(handles.activetype).minwidth;

switch get(gco,'tag') %grabber order: [SW NW NE SE];
    case 'NE'
        %enforce minimum graph size:
        if endx<get(handles.grabbers{handles.activeindex}(1),'xdata')+minwidth
            endx=get(handles.grabbers{handles.activeindex}(1),'xdata')+minwidth;
        end
        
        if endy<get(handles.grabbers{handles.activeindex}(1),'ydata')+minheight-1
            endy=get(handles.grabbers{handles.activeindex}(1),'ydata')+minheight-1;
        end
        
        set(gco,'xdata',endx-3,'ydata',endy-2)
        set(handles.grabbers{handles.activeindex}(2),'ydata',endy-2)
        set(handles.grabbers{handles.activeindex}(4),'xdata',endx-3)
        
    case 'SE'
        %enforce minimum graph size:
        if endx<get(handles.grabbers{handles.activeindex}(1),'xdata')+minwidth
            endx=get(handles.grabbers{handles.activeindex}(1),'xdata')+minwidth;
        end
        
        if endy>get(handles.grabbers{handles.activeindex}(2),'ydata')-minheight
            endy=get(handles.grabbers{handles.activeindex}(2),'ydata')-minheight;
        end
        
        set(gco,'xdata',endx-3,'ydata',endy+3)
        set(handles.grabbers{handles.activeindex}(1),'ydata',endy+3)
        set(handles.grabbers{handles.activeindex}(3),'xdata',endx-3)
        
    case 'NW'
        %enforce minimum graph size:
        if endx>get(handles.grabbers{handles.activeindex}(3),'xdata')-minwidth-1
            endx=get(handles.grabbers{handles.activeindex}(3),'xdata')-minwidth-1;
        end
        
        if endy<get(handles.grabbers{handles.activeindex}(1),'ydata')+minheight-1
            endy=get(handles.grabbers{handles.activeindex}(1),'ydata')+minheight-1;
        end
        
        set(gco,'xdata',endx+2,'ydata',endy-2)
        set(handles.grabbers{handles.activeindex}(3),'ydata',endy-2)
        set(handles.grabbers{handles.activeindex}(1),'xdata',endx+2)
    case 'SW'
        %enforce minimum graph size:
        if endx>get(handles.grabbers{handles.activeindex}(3),'xdata')-minwidth-1
            endx=get(handles.grabbers{handles.activeindex}(3),'xdata')-minwidth-1;
        end
        
        if endy>get(handles.grabbers{handles.activeindex}(3),'ydata')-minheight
            endy=get(handles.grabbers{handles.activeindex}(3),'ydata')-minheight;
        end
        set(gco,'xdata',endx+2,'ydata',endy+3)
        set(handles.grabbers{handles.activeindex}(4),'ydata',endy+3)
        set(handles.grabbers{handles.activeindex}(2),'xdata',endx+2)
end



bpos=[get(handles.grabbers{handles.activeindex}(1),'xdata')-2 get(handles.grabbers{handles.activeindex}(1),'ydata')-3 ...
    get(handles.grabbers{handles.activeindex}(3),'xdata')-get(handles.grabbers{handles.activeindex}(1),'xdata')+5 ...
    get(handles.grabbers{handles.activeindex}(3),'ydata')-get(handles.grabbers{handles.activeindex}(1),'ydata')+5];

set([handles.allblockers(handles.activeindex) handles.expblockers(handles.activeindex)],'position',bpos)

widthinches=sprintf('%5.2f',round(bpos(3)/96*4)/4);
heightinches=sprintf('%5.2f',round(bpos(4)/96*4)/4);
set(handles.infobar,'string',['Width=',widthinches,'" Height=',heightinches,'" at 96dpi resolution'])

% p=handles.fakerax(handles.activeindex); %uipanel of this table
% %maxpos=[bpos(1)+10 bpos(2)+20 bpos(3)-30 bpos(4)-30];
% 
% if isempty(udata.format.title)
%     maxpos=bpos+[24 26 -46 -41];
% else
%     maxpos=bpos+[24 26 -46 -61];
% end
% 
% tpos=get(handles.activegraph,'position');
% tablesize=[0 0 udata.view.headerwidth+tpos(3) udata.view.headerheight+tpos(4)];
% 
% handles.temp.oldpos=get(p,'position');
% 
% if udata.view.tight && tablesize(3)<maxpos(3)
%     %table is smaller than the uipanel, so shrink uipanel to just hold table.
%     newpos(1)=bpos(1)+(maxpos(3)-tablesize(3))/2+24;
%     newpos(3)=tablesize(3);
% else
%     newpos(1)=bpos(1)+24;
%     newpos(3)=maxpos(3);
% end
% 
% if udata.view.tight && tablesize(4)<maxpos(4)
%     %table is smaller than the uipanel, so shrink uipanel to just hold table.
%     newpos(2)=bpos(2)+(maxpos(4)-tablesize(4))/2+26;
%     newpos(4)=tablesize(4);
% else
%     newpos(2)=bpos(2)+26;
%     newpos(4)=maxpos(4);
% end
% 
% 
% set(p,'position',[newpos(1) newpos(2) newpos(3) newpos(4)]);

% 
% pos=get(p,'position');
% tpos=get(handles.fakeax(handles.activeindex),'position');
% 
% t=get(handles.fakeax(handles.activeindex),'position');
% hstep=(pos(3)-udata.view.headerwidth);
% vstep=(pos(4)-udata.view.headerheight);
% 
% 
% if ~isempty(udata.view.hscroll)
%     userdata=get(udata.view.hscroll(1),'userdata');
%     hslidevalue=userdata(2);
%     [haxhandles]=drawhscroll(handles.wspanel,handles.activegraph,[pos(1) pos(2)-17 pos(3)-1 17],0,t(3),hstep,hslidevalue,@horztablescroll,1);
%     delete(udata.view.hscroll);
%     udata.view.hscroll=haxhandles;
% end
% 
% 
% if ~isempty(udata.view.vscroll)
%     userdata=get(udata.view.vscroll(1),'userdata');
%     vslidevalue=userdata(2);
%     [vaxhandles]=drawvscroll(handles.wspanel,handles.activegraph,[pos(1)+pos(3) pos(2)+1 17 pos(4)-1],0,t(4),vstep,vslidevalue,@verttablescroll,1);
%     delete(udata.view.vscroll);
%     udata.view.vscroll=vaxhandles;
% end
set(handles.fakeax(handles.activeindex),'userdata',udata);
guidata(handles.fig,handles);
raveresizetable(handles.fig,[],handles.activeindex);


function ravemovetabledone(src,eventdata)
handles=guidata(src);
set(handles.fig,'windowbuttonmotionfcn','');
set(handles.fig,'windowbuttonupfcn','');

set(handles.infobar,'string','');
