function ravemoveview(varargin)
%NOTE: this function depends on using varargin instead of specifying an exact number of inputs,
%so don't change that in the future.
%
%ravemoveview(handles.fig,[],clicked);
%clicked is optional
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


src=varargin{1};

handles=guidata(src);

%get existing position and click location
oldviewpos=get(handles.currentview,'position');
wsextent=get(handles.wspanel,'position');
lastpos=wsextent;


if numel(varargin)==3
    clicked=varargin{3};
    %round to nearest integers:
    clicked=floor(clicked);

else
    clicked=get(handles.explorer,'currentpoint');
    %round to nearest integers:
    clicked=floor(clicked);


    %update scrollbars
    if clicked(1,2,1)>handles.wsdims(2)-oldviewpos(4)/2
        set(handles.vscroll,'value',handles.wsdims(2)-oldviewpos(4)/2)
    elseif clicked(1,2,1)<oldviewpos(4)/2
        set(handles.vscroll,'value',oldviewpos(4)/2)
    else
        set(handles.vscroll,'value',clicked(1,2,1))
    end
    
    if clicked(1,1,1)>handles.wsdims(1)-oldviewpos(3)/2
        set(handles.hscroll,'value',handles.wsdims(1)-oldviewpos(3)/2)
    elseif clicked(1,1,1)<oldviewpos(3)/2
        set(handles.hscroll,'value',oldviewpos(3)/2)
    else
        set(handles.hscroll,'value',clicked(1,1,1))
    end

end




%center box on click location
clicked(1,1,1)=clicked(1,1,1)-oldviewpos(3)/2;
clicked(1,2,1)=clicked(1,2,1)-oldviewpos(4)/2;

%limit new location to always be inside workspace
if clicked(1,1,1)+oldviewpos(3)>wsextent(3)
    clicked(1,1,1)=wsextent(3)-oldviewpos(3);
elseif clicked(1,1,1)<0
    clicked(1,1,1)=0;
end

if clicked(1,2,1)+oldviewpos(4)>wsextent(4)
    clicked(1,2,1)=wsextent(4)-oldviewpos(4);
elseif clicked(1,2,1)<0
    clicked(1,2,1)=0;
end

%round to nearest integers:
clicked=floor(clicked);


%move to new location
set(handles.currentview,'position',[clicked(1,1,1) clicked(1,2,1) oldviewpos(3) oldviewpos(4)]);

%allow dragging
if numel(varargin)~=3
    set(handles.fig,'WindowButtonMotionFcn',@ravemoveview);
    set(handles.fig,'WindowButtonUpFcn',@movedone);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%update workspace to show new view:
%calculate where to put it.
mainaxespos=get(handles.wspanel,'position');
cvpos=get(handles.currentview,'position');
wspos=handles.workspacepos;
wsextent=get(handles.mainaxes,'position');

mainaxespos(1)=wspos(1)-cvpos(1);
mainaxespos(2)=wspos(2)-cvpos(2);

if cvpos(1)==0
    mainaxespos(1)=mainaxespos(1)+0;
end

if cvpos(1)+cvpos(3)>=wsextent(3)
    mainaxespos(1)=mainaxespos(1)+2;
end

if cvpos(2)==0
    mainaxespos(2)=mainaxespos(2)-2;
end

if cvpos(2)+cvpos(4)>=wsextent(4)
    mainaxespos(2)=mainaxespos(2)+1;
end

set(handles.wspanel,'position',mainaxespos);

%fix table uipanel bug:
for ai=1:numel(handles.allgraphs)
   if ishandle(handles.fakerax(ai)) && strcmp(get(handles.fakerax(ai),'type'),'uipanel');
       p=handles.fakerax(ai);
       ppos=get(p,'position');
       set(p,'position',ppos); %makes table redraw in correct position
   end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



function movedone(src,eventdata)
%load handles
handles=guidata(src);

%stop dragging
set(handles.fig,'WindowButtonMotionFcn',[]);



%update workspace to show new view:
%calculate where to put it.
mainaxespos=get(handles.wspanel,'position');
cvpos=get(handles.currentview,'position');
wspos=handles.workspacepos;
wsextent=get(handles.mainaxes,'position');

mainaxespos(1)=wspos(1)-cvpos(1);
mainaxespos(2)=wspos(2)-cvpos(2);

if cvpos(1)==0
    mainaxespos(1)=mainaxespos(1)+0;
end

if cvpos(1)+cvpos(3)>=wsextent(3)
    mainaxespos(1)=mainaxespos(1)+2;
end

if cvpos(2)==0
    mainaxespos(2)=mainaxespos(2)-2;
end

if cvpos(2)+cvpos(4)>=wsextent(4)
    mainaxespos(2)=mainaxespos(2)+1;
end

set(handles.wspanel,'position',mainaxespos);






