function raveresizetable(src,ev,targetindex) %#ok<INUSL>

%RAVE: resize all children of the uipanel to fit inside the panel. display scrollbars if necessary.
%reposition children of table uipanel to keep the upper-left corner in a
%constant postiion while resizing table. 
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);
udata=get(handles.fakeax(targetindex),'userdata');

p=handles.fakerax(targetindex);

%%%%%%%%%%%%%%%%%%%%%%%%%

bpos=[get(handles.grabbers{targetindex}(1),'xdata')-2 get(handles.grabbers{targetindex}(1),'ydata')-3 ...
    get(handles.grabbers{targetindex}(3),'xdata')-get(handles.grabbers{targetindex}(1),'xdata')+5 ...
    get(handles.grabbers{targetindex}(3),'ydata')-get(handles.grabbers{targetindex}(1),'ydata')+5];

if isempty(udata.format.title)
    maxpos=bpos+[24 26 -46 -41];
else
    maxpos=bpos+[24 26 -46 -61];
end

tpos=get(handles.allgraphs(targetindex),'position');
tablesize=[0 0 udata.view.headerwidth+tpos(3) udata.view.headerheight+tpos(4)];

oldpos=get(p,'position');

if udata.view.tight && tablesize(3)<maxpos(3)
    %table is smaller than the uipanel, so shrink uipanel to just hold table.
    newpos(1)=bpos(1)+(maxpos(3)-tablesize(3))/2+24;
    newpos(3)=tablesize(3);
else
    newpos(1)=bpos(1)+24;
    newpos(3)=maxpos(3);
end

if udata.view.tight && tablesize(4)<maxpos(4)
    %table is smaller than the uipanel, so shrink uipanel to just hold table.
    newpos(2)=bpos(2)+(maxpos(4)-tablesize(4))/2+26;
    newpos(4)=tablesize(4);
else
    newpos(2)=bpos(2)+26;
    newpos(4)=maxpos(4);
end


set(p,'position',newpos);

%tpos=get(handles.fakeax(targetindex),'position');
pos=newpos;
t=get(handles.fakeax(targetindex),'position');
hstep=(pos(3)-udata.view.headerwidth);
vstep=(pos(4)-udata.view.headerheight);


if ~isempty(udata.view.hscroll)
    userdata=get(udata.view.hscroll(1),'userdata');
    hslidevalue=userdata(2);
    try
    [haxhandles]=drawhscroll(handles.wspanel,handles.allgraphs(targetindex),[pos(1) pos(2)-17 pos(3)-1 17],0,t(3),hstep,hslidevalue,@horztablescroll,1);
    catch
        return
    end
    
    delete(udata.view.hscroll);
    udata.view.hscroll=haxhandles;
end


if ~isempty(udata.view.vscroll)
    userdata=get(udata.view.vscroll(1),'userdata');
    vslidevalue=userdata(2);
    [vaxhandles]=drawvscroll(handles.wspanel,handles.allgraphs(targetindex),[pos(1)+pos(3) pos(2)+1 17 pos(4)-1],0,t(4),vstep,vslidevalue,@verttablescroll,1);
    delete(udata.view.vscroll);
    udata.view.vscroll=vaxhandles;
end

set(handles.fakeax(targetindex),'userdata',udata);

%%%%%%%%%%%%%%%%%%%%%%%%%%


cornerblocker=findobj(p,'tag','cornerblocker');
chax=findobj(p,'tag','colheader');
rhax=findobj(p,'tag','rowheader');
tax=handles.fakeax(targetindex);
dax=handles.allgraphs(targetindex);


if isempty(chax);chax=[];end;
if isempty(rhax);rhax=[];end;


newpos=get(p,'position');
% try 
%     oldpos=handles.temp.oldpos;
% catch
%     oldpos=newpos;
% end

set(udata.format.titleaxes,'position',[newpos(1) newpos(2)+newpos(4)+5 newpos(3) 30]);


deltah=newpos(4)-oldpos(4);
%deltaw=newpos(3)-oldpos(3);

kiddies=[chax rhax tax dax];

positions=get(kiddies,'position');

positions=cell2mat(positions);
positions=bsxfun(@plus,positions,[0 deltah 0 0]);

set(cornerblocker,'position',[positions(2,1) positions(1,2) positions(2,3) positions(1,4)]);

positions=mat2cell(positions,ones(size(positions,1),1),4);

set(kiddies,{'position'},positions);

%guidata(handles.fig,handles);




