function ravesavestate(src,eventdata)
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);

%ask user for a name for this project.

h=ravesavegui([],handles.projectname);
uiwait(h);

path=handles.defaultdir;
name=get(0,'userdata');
set(0,'userdata','')

if ~isempty(name)
    %delete tray icon:
    
    pause(0.1) %to avoid java crash
    sysTray = java.awt.SystemTray.getSystemTray;
    if (sysTray.isSupported)
        java.awt.SystemTray.getSystemTray.remove(handles.trayIcon);
    end
    pause(0.1)
    handles.trayIcon=[];
    handles.projectname=name;
    guidata(handles.fig,handles);
    
    
  %  msgstate=warning('query','MATLAB:Java:ConvertFromOpaque');
  %  warning('off','MATLAB:Java:ConvertFromOpaque');
    
    mkdir([path,'\',name]);
    
    filename=fullfile(path,name,[name '.rve']);
    
    hgS = handle2struct(handles.fig);
    SaveVer = '070000'; %if error, change to '080000'
    SaveVars.(sprintf('hgS_%s', SaveVer)) = hgS;
  
    %no, really:
    SaveVars.hgS_070000.properties.ApplicationData.UsedByGUIData_m.maintable.jtable=[];
    SaveVars.hgS_070000.properties.ApplicationData.UsedByGUIData_m.maintable.defaultRowHeaderRenderer=[];
    
    save(filename, '-struct', 'SaveVars');

    handles.activedir=path;
    
    %restore tray icon:
    
    %make tray icon:
    
    if (sysTray.isSupported)
        raveroot=which('rave');
        raveroot=raveroot(1:end-6);
        myIcon = fullfile(raveroot,'images\tinyrave.png');
        iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
        handles.trayIcon = java.awt.TrayIcon(iconImage, 'initial tooltip');
        handles.trayIcon.setToolTip('RAVE is running.');
        sysTray.add(handles.trayIcon)
    else
        handles.trayIcon=[];
    end

    ravefinish
    set(handles.infobar,'string','Project saved successfully.')
    
    
   % warning(msgstate.state,'MATLAB:Java:ConvertFromOpaque');
    
end

guidata(src,handles);