function ravesendtxtmessage(src,ev,mess)
%send message in string "mess" to users phone.
%to use this funciton, you must have email set up in MATLAB. You can use
%these settings: (see "help setpref")
%
% setpref('Internet','E_mail','RaveAlerts@gmail.com')
% setpref('Internet','SMTP_Server','smtp.gmail.com')
% setpref('Internet','SMTP_Username','RaveAlerts@gmail.com')
% setpref('Internet','SMTP_Password','nowyouravin')
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


props=java.lang.System.getProperties;
pp=props.setProperty('mail.smtp.auth','true'); %#ok
pp=props.setProperty('mail.smtp.socketFactory.class','javax.net.ssl.SSLSocketFactory'); %#ok
pp=props.setProperty('mail.smtp.socketFactory.port','465'); %#ok


handles=guidata(src);

if isempty(handles.prefs.cellnumber)
    errordlg('You have not set your cell phone number in the raveprefs file.')
end


switch lower(handles.prefs.cellcarrier)
    case 'verizon'
        addy=[handles.prefs.cellnumber,'@vtext.com'];
    case {'att','cingular'}
        addy=[handles.prefs.cellnumber,'@txt.att.net'];
    case 'alltel'
        addy=[handles.prefs.cellnumber,'@message.alltel.com'];
    case 'boost mobile'
        addy=[handles.prefs.cellnumber,'@myboostmobile.com'];
    case 'nextel'
        addy=[handles.prefs.cellnumber,'@messaging.nextel.com'];
    case 'sprint nextel'
        addy=[handles.prefs.cellnumber,'@messaging.sprintpcs.com'];
    case 't-mobile'
        addy=[handles.prefs.cellnumber,'@tmomail.net'];
    case 'virgin mobile'
        addy=[handles.prefs.cellnumber,'@vmobl.com'];    
    otherwise
        errordlg('I dont know how to send a text message to your cell carrier.');
end

c=clock;
if c(4)>4 && c(4)<12
    mess=['Good morning, ',mess];
elseif c(4)>12 && c(4)<23
    mess=[mess, ' Have a nice day.'];
else
    mess=[mess,' Now get some sleep!'];
end




sendmail(addy,'RAVE Alert',mess);
