function ravevectorize(varargin)
%this function is the opposite of raverasterfarian. it removes the bitmap image and restores original
%graph.
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


src=varargin{1};
handles=guidata(src);

if nargin==3
    ai=varargin{3}; %index of graph to be vectorized;
else
    ai=handles.activeindex;
end

if isempty(handles.rasters{ai});return;end %this graph is already vectorized. (keep this for use in raveupdateanalysis)

try
visibiliteez=get(handles.rasters{ai},'userdata');
catch %#ok<CTCH>
    warning('There was a problem vectorizing a graph.');
    return
end

set(handles.allgraphs(ai),'visible','on')
set(handles.fakeax(ai),'visible','on')
set(handles.fakerax(ai),'visible','on')

type=get(handles.allgraphs(ai),'userdata');



allparents=[handles.allgraphs(ai);handles.fakeax(ai);handles.fakerax(ai);handles.subax{ai}(:);handles.subfakeax{ai}(:);handles.subfakerax{ai}(:);handles.statsax{ai}(:)];
allkidz=get(allparents,'children');
if iscell(allkidz);
    allkidz=cell2mat(allkidz);
end

showdeez=[allparents;allkidz];
set(showdeez,{'visible'},visibiliteez);

%delete raster axes 
delete(handles.rasters{ai});
handles.rasters{ai}=[];


%restore explorer blocker color.
set(handles.expblockers(ai),'facecolor',[.7 .7 .7]);

guidata(handles.fig,handles);

